#ifdef USE_TI89
    #include "Lava.h"
    #define Y0          10
#else
    #define Y0          0
    #define LCD_W       160
    #define LCD_H       80
#endif

#define MENU_DELAY      40
#define DTIME           50*256/1000
#define MAP_W           144     //ĻĿ
#define MAP_H           LCD_H   //Ļĸ߶
#define KEY_SHOOT       28  //'z'
#define KEY_PAUSE       29  //'p'
#define KEY_SAVE        30  //'s'
#define KEY_READ        31  //'r'
#define KEY_ESC         27  //
#define KEY_UP          20  //巽
#define KEY_DOWN        21  //巽
#define KEY_RIGHT       22  //巽
#define KEY_LEFT        23  //巽
#define BASE_TIME       180
#define PAUSE_TIME      180
#define SUPER_TIME      220
#define ENEMY_SHOOT     2   //ǹ
#define ENEMY_MAX       3   //
#define BOMB_MAX        4   //ը
#define SHOW_TIME       50
#define ITEM_TIME       160
#define SHOW_PASS_TIME  40
#define SHOW_DEAD_TIME  40

char ms0;
char MoveSpeed; //Ϸߵƶٶ
char arrowsleep;

char optionid;
char enemyshowx[ENEMY_MAX];
char enemyshowid;
char key; //̵Ĳ
char level;


//ʱı
struct Game
{
    char curRound;
    char maxRound;
    char mapMode;
    //
    char px;        //ҷ x
    char py;        //ҷ y
    char pState;    //ҷǰ״̬, С˵ĵǰƶʽҵ״̬
    char pMove;     //ԶƶӦ8ĵͼ
    char pLife;
    char pGun;
    //
    char maxEnemy;  // ͬ
    char lastEnemy; // ʣ
    //
    char pauseTime;
    char superTime;
    char baseTime;
    char passDelay;
    char deadDelay;
};
struct Game game;


//ı
struct Item
{
    char x;
    char y;
    char time;
    char style;
    char state;
};
struct Item item;

struct Enemy  //EnemyĽṹ
{
    char x; //˵X
    char y; //˵Y
    char xspeed; //˵ٶ
    char yspeed;
    char state; //˵״̬
    char arrow; //
    //
    char style; //˵ʽ
    char earrrnd; //˵Ļó̶
    char life;
    char showtime;
    char sleep;
};

struct PlayerGun
{
    char x;
    char y;
    char xspeed;
    char yspeed;
    char state;
    char arrow;
};

struct EnemyGun
{
    char x;
    char y;
    char xspeed;
    char yspeed;
    char state;
    char arrow;
    char sleep;
};

struct Bomb
{
    char x;
    char y;
    char state;
    char id;
    char bs;
};

struct Bomb bomb[BOMB_MAX];
struct PlayerGun pg;
struct EnemyGun eg[ENEMY_SHOOT];
struct Enemy en[ENEMY_MAX]; //EnemyҪı

char i; //Ҫѭ
char j;
char speed_level;
char delaylevel; // 0~7
char delaytime;
char eblock;
char Tx, Ty;
char sys_roundmax;
char ext_roundmax;
char select;
char dxy[6] = { 0, 0, -4, 4, 0, 0};// dx:0~3,  dy: 2~5

//ͼ
//ͼ[y][x]
//sence wawaͼƬ
char sence[MAP_H/8][MAP_W/8];

char bmp_wawa[32*32/8] =
{
    // WAWAͼƬ 32 * 32: 128bytes
    0x00,0x01,0xE0,0x00,0x08,0xE2,0x10,0x00,0x49,0x14,0x08,0x00,0x22,0x6B,0x04,0x00,
    0x12,0x6B,0x04,0x00,0xC2,0x08,0x04,0x00,0x21,0x18,0x04,0x00,0x02,0xE4,0x08,0x00,
    0x04,0x02,0x10,0x00,0x09,0xF1,0xE8,0x00,0x0F,0xFC,0x04,0x00,0x0C,0x07,0x22,0x00,
    0x10,0x01,0xF1,0x00,0x10,0x00,0x11,0x00,0x10,0x00,0x20,0x80,0x10,0x00,0x00,0x80,
    0x10,0x00,0x00,0x40,0x10,0x00,0x00,0x40,0x10,0x00,0x00,0x20,0x10,0x00,0x00,0x20,
    0x08,0x00,0x03,0x10,0x08,0x00,0x04,0x90,0x04,0x00,0x04,0x10,0x02,0x00,0x06,0xF0,
    0x01,0x00,0x1E,0x60,0x03,0xFF,0xFC,0x20,0x3B,0xFF,0xEF,0xF0,0xFF,0xDF,0xFF,0xFC,
    0x1F,0x3F,0xFF,0xE2,0xE0,0xDF,0xFC,0x1C,0x1F,0x20,0x03,0xE0,0x00,0x3F,0xFC,0x00
};

char bmp_bomman[160*80/8] =
{
    0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7E,
    0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7E,
    0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7E,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF6,
    0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF6,
    0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF6,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x7E, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0x00, 0x00, 0x00, 0x00, 0xFD, 0x02, 0x00, 0xFC, 0x00, 0xFD, 0x7E,
    0x7E, 0x78, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x06, 0x00, 0x00, 0x00, 0x01, 0x06, 0xB4, 0x01, 0x06, 0x01, 0x07, 0x7E,
    0x7E, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x3E, 0x00, 0x00, 0x00, 0x01, 0x76, 0xFC, 0x01, 0x76, 0x01, 0x77, 0x7E,
    0x00, 0xFC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x3E, 0x00, 0x00, 0x00, 0x01, 0x47, 0xFE, 0x01, 0x46, 0x01, 0x46, 0x00,
    0xF7, 0x32, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x3E, 0x00, 0x00, 0x00, 0x01, 0x47, 0x32, 0x01, 0x46, 0x01, 0x47, 0xF6,
    0xF6, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xFE, 0x00, 0x00, 0x00, 0x01, 0x0F, 0xFE, 0x01, 0x0E, 0x01, 0x0F, 0xF6,
    0xF6, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xFE, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x7A, 0x01, 0xFE, 0x01, 0xFF, 0xF6, 
    0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0x00, 0x00, 0x00, 0x00, 0xFC, 0x84, 0x00, 0xFC, 0x00, 0xFC, 0x00, 
    0x7E, 0x00, 0xFC, 0x78, 0x78, 0x78, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0x78, 0xFC, 0xFC, 0x00, 0xFD, 0x7E, 
    0x7E, 0x01, 0x06, 0xFC, 0xFC, 0xFD, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x06, 0xFD, 0x07, 0x06, 0x01, 0x07, 0x7E, 
    0x7E, 0x01, 0x77, 0xC7, 0xC7, 0xC7, 0x77, 0x77, 0x3F, 0x77, 0x77, 0x77, 0x77, 0x77, 0xC7, 0x77, 0x76, 0x01, 0x77, 0x7E, 
    0x00, 0x01, 0x47, 0xAF, 0xAF, 0xAF, 0x47, 0x47, 0x3F, 0x47, 0x47, 0x47, 0x47, 0x47, 0xAF, 0x47, 0x46, 0x01, 0x46, 0x00, 
    0xF6, 0x01, 0x47, 0xD7, 0xD7, 0xD7, 0x47, 0x47, 0x3F, 0x47, 0x47, 0x47, 0x47, 0x47, 0xD7, 0x47, 0x46, 0x01, 0x47, 0xF6, 
    0xF6, 0x01, 0x0F, 0xFF, 0xFF, 0xFF, 0x0F, 0x0F, 0xFF, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0xFF, 0x0F, 0x0E, 0x01, 0x0F, 0xF6, 
    0xF6, 0x01, 0xFE, 0xFC, 0xFC, 0xFD, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0xFD, 0xFF, 0xFE, 0x01, 0xFF, 0xF6, 
    0x00, 0x00, 0xFC, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0x00, 0xFC, 0xFC, 0x00, 0xFC, 0x00, 
    0x7E, 0xFC, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0x00, 0x00, 0x00, 0x78, 0x00, 0xFC, 0x00, 0xFD, 0x7E, 
    0x7F, 0x06, 0x00, 0x00, 0x00, 0x01, 0x07, 0x07, 0x07, 0x07, 0x06, 0x00, 0x00, 0x00, 0xFC, 0x01, 0x06, 0x01, 0x07, 0x7E, 
    0x7F, 0x76, 0x00, 0x00, 0x00, 0x01, 0x3F, 0x3F, 0x3F, 0x3F, 0x3E, 0x00, 0x00, 0x01, 0xC6, 0x01, 0x76, 0x01, 0x77, 0x7E, 
    0x01, 0x46, 0x00, 0x00, 0x00, 0x01, 0x3F, 0x3F, 0x3F, 0x3F, 0x3E, 0x00, 0x00, 0x01, 0xAE, 0x01, 0x46, 0x01, 0x46, 0x00, 
    0xF7, 0x46, 0x00, 0x00, 0x00, 0x01, 0x3F, 0x3F, 0x3F, 0x3F, 0x3E, 0x00, 0x00, 0x01, 0xD6, 0x01, 0x46, 0x01, 0x47, 0xF6, 
    0xF7, 0x0E, 0x00, 0x00, 0x00, 0x01, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x00, 0x00, 0x01, 0xFE, 0x01, 0x0E, 0x01, 0x0F, 0xF6, 
    0xF7, 0xFE, 0x00, 0x00, 0x00, 0x01, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x00, 0x00, 0x00, 0xFC, 0x01, 0xFE, 0x01, 0xFF, 0xF6, 
    0x00, 0xFC, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0x00, 0xFC, 0x00, 
    0x7E, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0x78, 0x00, 0xFC, 0x00, 0xFD, 0x7E, 
    0x7F, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x06, 0xFC, 0x01, 0x06, 0x01, 0x07, 0x7E, 
    0x7F, 0x77, 0x77, 0x77, 0x77, 0x77, 0x77, 0x77, 0x77, 0x77, 0x77, 0x77, 0x77, 0x77, 0xC6, 0x01, 0x76, 0x01, 0x77, 0x7E, 
    0x01, 0x47, 0x47, 0x47, 0x47, 0x47, 0x47, 0x47, 0x47, 0x47, 0x47, 0x47, 0x47, 0x47, 0xAE, 0x01, 0x46, 0x01, 0x46, 0x00, 
    0xF7, 0x47, 0x47, 0x47, 0x47, 0x47, 0x47, 0x47, 0x47, 0x47, 0x47, 0x47, 0x47, 0x47, 0xD6, 0x01, 0x46, 0x01, 0x47, 0xF6, 
    0xF7, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0xFE, 0x01, 0x0E, 0x01, 0x0F, 0xF6, 
    0xF7, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0xFC, 0x01, 0xFF, 0x03, 0xFF, 0xF6, 
    0x00, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0x00, 0x00, 0xFC, 0xB4, 0xFC, 0x00, 
    0x7E, 0xFC, 0xFC, 0xFC, 0x00, 0x00, 0x00, 0x00, 0xFC, 0x00, 0x00, 0x20, 0x40, 0xFC, 0x78, 0x00, 0xFC, 0xFC, 0xFD, 0x7E, 
    0x7F, 0x07, 0x07, 0x06, 0x00, 0x00, 0x00, 0x01, 0x06, 0x00, 0x00, 0x16, 0x81, 0x06, 0xFC, 0x01, 0x07, 0xFF, 0x07, 0x7E, 
    0x7F, 0x77, 0x77, 0x76, 0x01, 0x02, 0x00, 0x01, 0x76, 0x00, 0x00, 0x1F, 0x81, 0x77, 0xC6, 0x01, 0x77, 0x33, 0x77, 0x7E, 
    0x01, 0x47, 0x47, 0x46, 0x00, 0xB4, 0x00, 0x01, 0x46, 0x00, 0x00, 0x3F, 0xC1, 0x47, 0xAE, 0x01, 0x47, 0xFF, 0x46, 0x00, 
    0xF7, 0x47, 0x47, 0x46, 0x00, 0xFC, 0x00, 0x01, 0x46, 0x00, 0x00, 0x26, 0x41, 0x47, 0xD6, 0x01, 0x47, 0x7B, 0x47, 0xF6, 
    0xF7, 0x0F, 0x0F, 0x0E, 0x01, 0xFE, 0x00, 0x01, 0x0E, 0x00, 0x00, 0x3F, 0xC1, 0x0F, 0xFE, 0x01, 0x0E, 0x85, 0x0F, 0xF6, 
    0xF7, 0xFF, 0xFF, 0xFE, 0x01, 0x32, 0x00, 0x01, 0xFE, 0x00, 0x00, 0x2F, 0x41, 0xFE, 0xFC, 0x01, 0xFE, 0x01, 0xFF, 0xF6, 
    0x00, 0xFC, 0xFC, 0xFC, 0x01, 0xFE, 0x00, 0x00, 0xFC, 0x00, 0x00, 0x10, 0x80, 0xFC, 0x00, 0x00, 0xFC, 0x00, 0xFC, 0x00, 
    0x7E, 0x00, 0xFC, 0x00, 0xFD, 0x7A, 0x78, 0xFC, 0x00, 0x78, 0x78, 0x00, 0xFC, 0xFC, 0x78, 0x00, 0xFC, 0x00, 0xFD, 0x7E, 
    0x7E, 0x01, 0x06, 0x01, 0x06, 0x84, 0xFD, 0x06, 0x00, 0xFC, 0xFC, 0x01, 0x07, 0x06, 0xFC, 0x01, 0x06, 0x01, 0x07, 0x7E, 
    0x7E, 0x01, 0x76, 0x01, 0x76, 0x01, 0xC7, 0x76, 0x01, 0xC7, 0xC6, 0x01, 0x77, 0x77, 0xC6, 0x01, 0x76, 0x01, 0x77, 0x7E, 
    0x00, 0x01, 0x46, 0x01, 0x46, 0x01, 0xAF, 0x46, 0x01, 0xAF, 0xAE, 0x01, 0x47, 0x47, 0xAE, 0x01, 0x46, 0x01, 0x46, 0x00, 
    0xF6, 0x01, 0x46, 0x01, 0x46, 0x01, 0xD7, 0x46, 0x01, 0xD7, 0xD6, 0x01, 0x47, 0x47, 0xD6, 0x01, 0x46, 0x01, 0x47, 0xF6, 
    0xF6, 0x01, 0x0E, 0x01, 0x0E, 0x01, 0xFF, 0x0E, 0x01, 0xFF, 0xFE, 0x01, 0x0F, 0x0F, 0xFE, 0x01, 0x0E, 0x01, 0x0F, 0xF6, 
    0xF6, 0x79, 0xFE, 0x01, 0xFE, 0x00, 0xFD, 0xFE, 0x00, 0xFC, 0xFC, 0x01, 0xFF, 0xFE, 0xFC, 0x01, 0xFE, 0x01, 0xFF, 0xF6, 
    0x00, 0xFC, 0xFC, 0x00, 0xFC, 0x00, 0x00, 0xFC, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0x00, 0x00, 0xFC, 0x00, 0xFC, 0x00, 
    0x7F, 0xB6, 0xFC, 0x00, 0xFC, 0x00, 0x78, 0xFC, 0x00, 0x78, 0x78, 0x00, 0xFC, 0xFC, 0x78, 0xFC, 0xFC, 0x00, 0xFD, 0x7E, 
    0x7F, 0xB7, 0x06, 0x01, 0x06, 0x00, 0xFD, 0x06, 0x00, 0xFC, 0xFC, 0x01, 0x07, 0x06, 0xFD, 0x07, 0x06, 0x01, 0x07, 0x7E, 
    0x7F, 0xFF, 0x76, 0x01, 0x76, 0x01, 0xC7, 0x76, 0x01, 0xC7, 0xC6, 0x01, 0x77, 0x77, 0xC7, 0x77, 0x76, 0x01, 0x77, 0x7E, 
    0x00, 0x01, 0x46, 0x01, 0x46, 0x01, 0xAF, 0x46, 0x01, 0xAF, 0xAE, 0x01, 0x47, 0x47, 0xAF, 0x47, 0x46, 0x01, 0x46, 0x00, 
    0xF6, 0xC5, 0x46, 0x01, 0x46, 0x01, 0xD7, 0x46, 0x01, 0xD7, 0xD6, 0x01, 0x47, 0x47, 0xD7, 0x47, 0x46, 0x01, 0x47, 0xF6, 
    0xF6, 0x6D, 0x0E, 0x01, 0x0E, 0x01, 0xFF, 0x0E, 0x01, 0xFF, 0xFE, 0x01, 0x0F, 0x0F, 0xFF, 0x0F, 0x0E, 0x01, 0x0F, 0xF6, 
    0xF6, 0x01, 0xFE, 0x01, 0xFE, 0x00, 0xFD, 0xFE, 0x00, 0xFC, 0xFC, 0x01, 0xFF, 0xFE, 0xFD, 0xFF, 0xFE, 0x01, 0xFF, 0xF6, 
    0x00, 0x00, 0xFC, 0x00, 0xFC, 0x00, 0x00, 0xFC, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0x00, 0xFC, 0xFC, 0x00, 0xFC, 0x00, 
    0x7E, 0x00, 0xFC, 0x00, 0x00, 0x00, 0x78, 0xFC, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0x00, 0xFD, 0x7E, 
    0x7E, 0x01, 0x06, 0x00, 0x00, 0x00, 0xFD, 0x06, 0x00, 0xFC, 0xFC, 0x00, 0x00, 0x00, 0x01, 0x07, 0x06, 0x01, 0x07, 0x7E, 
    0x7E, 0x01, 0x76, 0x00, 0x00, 0x01, 0xC7, 0x76, 0x01, 0xC7, 0xC6, 0x00, 0x00, 0x00, 0x01, 0x77, 0x76, 0x01, 0x77, 0x7E, 
    0x00, 0x01, 0x46, 0x00, 0x00, 0x01, 0xAF, 0x46, 0x01, 0xAF, 0xAE, 0x00, 0x00, 0x00, 0x01, 0x47, 0x46, 0x01, 0x46, 0x00, 
    0xF6, 0x01, 0x46, 0x00, 0x00, 0x01, 0xD7, 0x46, 0x01, 0xD7, 0xD6, 0x00, 0x00, 0x00, 0x01, 0x47, 0x46, 0x01, 0x47, 0xF6, 
    0xF6, 0x01, 0x0E, 0x00, 0x00, 0x01, 0xFF, 0x0E, 0x01, 0xFF, 0xFE, 0x00, 0x00, 0x00, 0x01, 0x0F, 0x0E, 0x01, 0x0F, 0xF6, 
    0xF6, 0x01, 0xFE, 0x00, 0x00, 0x00, 0xFD, 0xFE, 0x00, 0xFC, 0xFC, 0x00, 0x00, 0x00, 0x01, 0xFF, 0xFE, 0x01, 0xFF, 0xF6, 
    0x00, 0x00, 0xFC, 0x00, 0x00, 0x00, 0x00, 0xFC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0x00, 0xFC, 0x00, 
    0x7E, 0x00, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0x00, 0x78, 0x78, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0x00, 0xFD, 0x7E, 
    0x7E, 0x01, 0x07, 0x07, 0x07, 0x07, 0x07, 0x06, 0x00, 0xFC, 0xFD, 0x07, 0x07, 0x07, 0x07, 0x07, 0x06, 0x01, 0x07, 0x7E, 
    0x7E, 0x01, 0x77, 0x77, 0x77, 0x77, 0x77, 0x76, 0x01, 0xC7, 0xC7, 0x77, 0x77, 0x77, 0x77, 0x77, 0x76, 0x01, 0x77, 0x7E, 
    0x00, 0x01, 0x47, 0x47, 0x47, 0x47, 0x47, 0x46, 0x01, 0xAF, 0xAF, 0x47, 0x47, 0x47, 0x47, 0x47, 0x46, 0x01, 0x46, 0x00, 
    0xF6, 0x01, 0x47, 0x47, 0x47, 0x47, 0x47, 0x46, 0x01, 0xD7, 0xD7, 0x47, 0x47, 0x47, 0x47, 0x47, 0x46, 0x01, 0x47, 0xF6, 
    0xF6, 0x01, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0E, 0x01, 0xFF, 0xFF, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0E, 0x01, 0x0F, 0xF6, 
    0xF6, 0x01, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x00, 0xFC, 0xFD, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x01, 0xFF, 0xF6, 
    0x00, 0x00, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0x00, 0xFC, 0x00
};

char bmp_splash[160*80/8] =
{
    0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x07, 0x87, 0x80, 0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x03, 0x38, 0x00, 0x00, 0x00, 0x01, 0xC1, 0xDC, 0x68, 0x40, 0x00, 0x1F, 0xE7, 0xC3, 0xC0, 0x00, 0x00, 
    0x40, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x20, 0x00, 0x60, 0x00, 0x3C, 0x30, 0x00, 0x00, 
    0x80, 0x01, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x20, 0x00, 0x80, 0x00, 0x00, 0x10, 0x00, 0x00, 
    0x80, 0x01, 0x00, 0x04, 0x01, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x40, 0x40, 0x00, 0x80, 0x00, 0x00, 0x08, 0x00, 0x00, 
    0x80, 0x03, 0x00, 0x04, 0x06, 0x00, 0x00, 0x00, 0x02, 0x01, 0x00, 0x41, 0x80, 0x00, 0x60, 0x00, 0x40, 0x08, 0x00, 0x00, 
    0x60, 0x06, 0x00, 0x0F, 0x38, 0x00, 0x00, 0x00, 0x01, 0xC3, 0xC0, 0xC4, 0x00, 0x00, 0x1F, 0xC0, 0xC0, 0x10, 0x00, 0x00, 
    0x1E, 0x0F, 0x00, 0xF8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x63, 0xF8, 0x00, 0x00, 0x00, 0x61, 0x80, 0x70, 0x00, 0x00, 
    0x01, 0xF3, 0x87, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1C, 0x00, 0x00, 0x00, 0x00, 0x1F, 0xCD, 0x80, 0x00, 0x00, 
    0x00, 0x00, 0x78, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0xC0, 0x07, 0x01, 0x1F, 0x01, 0x0C, 0x0C, 
    0x01, 0xF0, 0x01, 0xC0, 0x47, 0xC0, 0x43, 0x03, 0x27, 0xC0, 0x67, 0xC0, 0x1C, 0x30, 0x1C, 0x07, 0xFC, 0x07, 0x7F, 0x7C, 
    0x07, 0x0C, 0x07, 0x01, 0xFF, 0x01, 0xDF, 0xDF, 0xFF, 0x01, 0xFF, 0x00, 0x30, 0x0C, 0x30, 0x0F, 0xF0, 0x0F, 0xFF, 0xFC, 
    0x0C, 0x03, 0x0C, 0x03, 0xFC, 0x03, 0xFF, 0xFF, 0xFC, 0x03, 0xFC, 0x02, 0x60, 0x02, 0x60, 0x01, 0xE0, 0x01, 0xAA, 0xA8, 
    0x18, 0x00, 0x98, 0x00, 0x78, 0x00, 0x6A, 0xAA, 0xB8, 0x00, 0x78, 0x00, 0xC6, 0x72, 0x46, 0x71, 0xC6, 0x71, 0x55, 0x54, 
    0x31, 0x9C, 0x91, 0x9C, 0x71, 0x9C, 0x55, 0x55, 0x71, 0x9C, 0x71, 0x9C, 0xC6, 0x03, 0xC6, 0x01, 0xC6, 0x01, 0x2A, 0x28, 
    0x31, 0x80, 0xF1, 0x80, 0x71, 0x80, 0x4A, 0x8A, 0xB1, 0x80, 0x71, 0x80, 0x86, 0x01, 0x86, 0x01, 0x86, 0x01, 0x00, 0x00, 
    0x21, 0x80, 0x61, 0x80, 0x61, 0x80, 0x40, 0x00, 0x21, 0x80, 0x61, 0x80, 0x86, 0x01, 0x86, 0x01, 0x86, 0x01, 0x00, 0x00, 
    0x21, 0x80, 0x61, 0x80, 0x61, 0x80, 0x40, 0x00, 0x21, 0x80, 0x61, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xF0, 0x70, 0x38, 0x71, 0xC1, 0xC0, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xF0, 0x70, 0x3C, 0x71, 0xC3, 0x80, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0xF8, 0x3C, 0x71, 0xC7, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0xF8, 0x3E, 0x71, 0xCE, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x01, 0xFF, 0xFF, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x01, 0xDC, 0x3F, 0x71, 0xDC, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x01, 0xDC, 0x3F, 0x71, 0xFE, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x0F, 0xF0, 0x07, 0x03, 0xDE, 0x3B, 0xF1, 0xFE, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x17, 0xFF, 0x7F, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xB0, 0x07, 0x03, 0x8E, 0x3B, 0xF1, 0xC7, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x17, 0xFF, 0x7F, 0xE8, 0x00, 0x00, 0x00, 0x1C, 0x30, 0x07, 0x03, 0xFE, 0x39, 0xF1, 0xC3, 0x80, 0x00, 
    0x00, 0x00, 0x00, 0x17, 0xFF, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x30, 0x07, 0x07, 0xFF, 0x38, 0xF1, 0xC3, 0x80, 0x00, 
    0x00, 0x00, 0x00, 0x17, 0xFF, 0x70, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xB0, 0x07, 0x07, 0x07, 0x38, 0xF1, 0xC1, 0xC0, 0x00, 
    0x00, 0x00, 0x02, 0x17, 0xFF, 0x7F, 0xE4, 0x00, 0x00, 0x00, 0x0F, 0xF0, 0x07, 0x0E, 0x03, 0xB8, 0x71, 0xC1, 0xE0, 0x00, 
    0x00, 0x00, 0x02, 0x37, 0xFF, 0xFF, 0xFA, 0x00, 0x7F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x02, 0x37, 0xFE, 0x00, 0x01, 0x00, 0x01, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x0F, 0x80, 0x00, 0xFF, 0xBF, 0xFF, 0xAE, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x1F, 0xBF, 0x7E, 0xAA, 0xBF, 0xFF, 0xAF, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x1F, 0xBF, 0x7E, 0xFF, 0xBF, 0xFF, 0xAF, 0xB0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x0A, 0xBF, 0x7E, 0xBE, 0xBF, 0xFF, 0xFF, 0xD8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x05, 0x3F, 0x7C, 0xFF, 0xBF, 0xFF, 0xAF, 0xEC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x3F, 0xFF, 0xFF, 0xFF, 0xFB, 0x00, 0x3F, 0xFF, 0xF6, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x80, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x1C, 0x1C, 0x0E, 0x00, 
    0x01, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x7F, 0x3E, 0x3E, 0x1E, 0x00, 
    0x03, 0x3F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x77, 0x77, 0x77, 0x3E, 0x00, 
    0x06, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x77, 0x77, 0x6E, 0x00, 
    0x04, 0xD5, 0x4C, 0xAA, 0xA6, 0x55, 0x53, 0x2A, 0x99, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0E, 0x77, 0x77, 0xEE, 0x00, 
    0x01, 0x84, 0xAD, 0x55, 0x56, 0xAA, 0xAB, 0x55, 0x5A, 0x42, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1C, 0x77, 0x77, 0xFF, 0x00, 
    0x01, 0x43, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0xE2, 0x00, 0x00, 0x00, 0x00, 0x00, 0x38, 0x77, 0x77, 0xFF, 0x00, 
    0x01, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0xD2, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0x3E, 0x3E, 0x0E, 0x00, 
    0x01, 0x43, 0x28, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFA, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0x1C, 0x1C, 0x0E, 0x00, 
    0x01, 0x80, 0x52, 0x94, 0xA5, 0x29, 0x4A, 0x52, 0x84, 0x72, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0xD5, 0x29, 0x4A, 0x52, 0x94, 0xA5, 0x29, 0x4A, 0x46, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x63, 0x9C, 0xE7, 0x39, 0xCE, 0x73, 0x9C, 0xE7, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x33, 0xDE, 0xF7, 0xBD, 0xEF, 0x7B, 0xDE, 0xF7, 0x98, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x19, 0x8C, 0x63, 0x18, 0xC6, 0x31, 0x8C, 0x63, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x0C, 0xE7, 0x39, 0xCE, 0x73, 0x9C, 0xE7, 0x39, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x54, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x2A, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xAA, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x7D, 0xFD, 0xFD, 0xFD, 0xFD, 0xFD, 0xFD, 0xFD, 0xFD, 0xFD, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xE0, 
    0x2A, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xA8, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xA0, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

char bmp_loading[56*10/8] =
{
    0xC0,0x00,0x0D,0x80,0x00,0x00,0x00,0xC3,0x8E,0x7C,
    0x3E,0xF8,0x00,0x00,0xC6,0xDB,0x6D,0xB6,0xD8,0x00,
    0x00,0xC6,0xDB,0x6D,0xB6,0xD8,0x00,0x00,0xC6,0xC7,
    0x6D,0xB6,0xD8,0x00,0x00,0xC6,0xDB,0x6D,0xB6,0xD8,
    0x00,0x00,0xC6,0xDB,0x6D,0xB6,0xF8,0x00,0x00,0xC6,
    0xDB,0x6D,0xB6,0x18,0xCC,0xC0,0xF3,0x9F,0x7D,0xB6,
    0xD8,0xCC,0xC0,0x00,0x00,0x00,0x00,0x70,0x00,0x00
};

// ˵Ե
char bmp_menu_title[90] =
{
    0x80,0x00,0x00,0x00,0x00,0x02,0xBF,0xFF,0xFF,0xFF,0xFF,0xFA,0xAF,0xFF,0xFF,0xFF,
    0xFF,0xEA,0xBF,0xE0,0xEF,0x7B,0x77,0xFA,0xBF,0xFB,0xD7,0x7B,0x6F,0xFA,0xBF,0xFB,
    0xD7,0x3B,0x5F,0xFA,0xBF,0xFB,0xD7,0x5B,0x3F,0xFA,0xBF,0xFB,0xBB,0x6B,0x3F,0xFA,
    0xBF,0xFB,0x83,0x73,0x5F,0xFA,0xBF,0xFB,0xBB,0x7B,0x6F,0xFA,0xBF,0xFB,0x7D,0x7B,
    0x77,0xFA,0xAF,0xFF,0xFF,0xFF,0xFF,0xEA,0xBF,0xFF,0xFF,0xFF,0xFF,0xFA,0x80,0x00,
    0x00,0x00,0x00,0x02,0xFF,0xFF,0xFF,0xFF,0xFF,0xFE
};
char bmp_menu_x0y0[20] =
{
    0xFF,0xC0,0xFF,0xC0,0xF0,0x00,0xEF,0xC0,0xF9,0xC0,0xD7,0xC0,0xDF,0xC0,0xFE,0x00,
    0xDE,0x00,0xDE,0x00
};
char bmp_menu_x0y1[12] =
{
    0xDF,0x00,0xDF,0xE0,0xD7,0xE0,0xD9,0xE0,0xEF,0xE0,0xF0,0x00
};
char bmp_menu_x1y0[13] =
{
    0xFF,0xFF,0x8F,0xF7,0x9B,0xEB,0xFB,0xFF,0x7B,0x7B,0x7B,0x7B,0x7B
};
char bmp_menu_x1y1[8] =
{
    0x7B,0x7B,0x7F,0xFB,0xEB,0x9B,0xF7,0x0F
};

// ˵ͼƬ
char bmp_menu_top[32*13/8] =
{
    0x30, 0x00, 0x00, 0x0C, 0x30, 0x00, 0x00, 0x0C, 0x30, 0x00, 0x00, 0x0C, 0x78, 0x00, 0x00, 0x0C, 0x58, 0x00, 0x7F, 0xFC, 0x58, 0x00, 0x7F, 0xFC, 0x78, 0x00, 0x60, 0x00, 0x78, 0x00, 0xF0, 0x00, 0xFC, 0x00, 0xF0, 0x00, 0x9C, 0x01, 0xF8, 0x00, 0xBC, 0x01, 0xB8, 0x00, 0xBC, 0x01, 0xB8, 0x00, 0xFC, 0x01, 0xF8, 0x00
};
char bmp_menu_right[8*32/8] =
{
    0xF0, 0x3F, 0xFF, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF0, 0x3F, 0xFF, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF0, 0x3F, 0xFF, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF0, 0x3F, 0xFF, 0xF0
};

char bmp_item[6][8] =
{
    0x18, 0x28, 0x18, 0xFF, 0x5A, 0x24, 0x18, 0x7E,  //base
    0x3C, 0x7E, 0xBD, 0x99, 0xFF, 0x7E, 0x24, 0x18,  //bomb
    0x18, 0x2C, 0x3C, 0x3C, 0x3C, 0x3C, 0x00, 0x3C,  //gun
    0x66, 0x7E, 0x7E, 0x5A, 0x66, 0x7E, 0x3C, 0x18,  //super
    0x00, 0x18, 0xE4, 0x3E, 0x41, 0xAB, 0x7E, 0x00,  //tank
    0x18, 0x3C, 0x42, 0x91, 0x9D, 0x81, 0x42, 0x3C   //time
};

char bmp_tile[5][8] =
{
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //հ
    0x7E, 0x83, 0xBB, 0xA3, 0xA3, 0x87, 0xFF, 0x7E, //שͷ
    0x7F, 0x7F, 0x7F, 0x00, 0xF7, 0xF7, 0xF7, 0x00, //ְ
    0x7E, 0x83, 0x9F, 0x9F, 0x9F, 0xFF, 0xFF, 0x7E, //ʯͷ
    0x3C, 0x7E, 0xCB, 0x95, 0xEF, 0xD5, 0x7E, 0x00  //
};

// з̹[type][dir][]
char bmp_enemy[3][4][8] =
{
    // type a
    0x18, 0x18, 0xFF, 0x42, 0xDB, 0x5A, 0xC3, 0x7E,
    0x7E, 0xC3, 0x5A, 0xDB, 0x42, 0xFF, 0x18, 0x18,
    0x2A, 0x3F, 0x21, 0xED, 0xED, 0x21, 0x3F, 0x2A,
    0x54, 0xFC, 0x84, 0xB7, 0xB7, 0x84, 0xFC, 0x54,
    // type b
    0x18, 0x18, 0x18, 0xFF, 0x66, 0x66, 0xE7, 0xBD,
    0xBD, 0xE7, 0x66, 0x66, 0xFF, 0x18, 0x18, 0x18,
    0x13, 0x1E, 0x1F, 0xF1, 0xF1, 0x1F, 0x1E, 0x13,
    0xC8, 0x78, 0xF8, 0x8F, 0x8F, 0xF8, 0x78, 0xC8,
    // type c
    0x18, 0x5A, 0x5A, 0xA5, 0xE7, 0xA5, 0xDB, 0x7E,
    0x7E, 0xDB, 0xA5, 0xE7, 0xA5, 0x5A, 0x5A, 0x18,
    0x1E, 0x6B, 0x1D, 0xE3, 0xE3, 0x1D, 0x6B, 0x1E,
    0x78, 0xD6, 0xB8, 0xC7, 0xC7, 0xB8, 0xD6, 0x78
};

// ҷ̹[dir][]
char bmp_player[4][8] =
{
    0x24, 0x24, 0xA5, 0x7E, 0xC3, 0x5A, 0xC3, 0xBD,
    0xBD, 0xC3, 0x5A, 0xC3, 0x7E, 0xA5, 0x24, 0x24,
    0x2B, 0x1E, 0xF1, 0x15, 0x15, 0xF1, 0x1E, 0x2B,
    0xD4, 0x78, 0x8F, 0xA8, 0xA8, 0x8F, 0x78, 0xD4
};

// ӵ[dir/2][]
char bmp_gun[2][8] =
{
    0x10, 0x08, 0x10, 0x08, 0x10, 0x08, 0x10, 0x08,
    0x00, 0x00, 0x00, 0x55, 0xAA, 0x00, 0x00, 0x00
};

char gif_bomb[5][8] =
{
    0x00, 0x00, 0x28, 0x10, 0x28, 0x14, 0x00, 0x00,
    0x00, 0x40, 0x1A, 0x24, 0x2C, 0x18, 0x42, 0x00,
    0x01, 0x5A, 0x34, 0x66, 0x6A, 0x72, 0x34, 0x82,
    0xB9, 0x64, 0xEA, 0xDE, 0xE4, 0x6C, 0xB2, 0x11,
    0x81, 0x5A, 0x3C, 0x6E, 0x7E, 0x3C, 0x5A, 0x81
};

char gif_show[2][8] =
{
    0x10, 0x18, 0x3C, 0x6F, 0xFE, 0x3C, 0x18, 0x08,
    0x81, 0x5A, 0x3C, 0x6E, 0x7E, 0x3C, 0x5A, 0x81
};

// 1~18س(ֽѹ)
char map[18][10][18/2] =
{
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x02, 0x20, 0x22, 0x00, 0x22, 0x02, 0x20, 0x20, 0x02, 0x02, 0x20, 0x22, 0x22, 0x22, 0x02, 0x20, 0x20, 0x02, 0x02, 0x20, 0x22, 0x00, 0x22, 0x02, 0x20, 0x20, 0x00, 0x02, 0x20, 0x22, 0x00, 0x22, 0x02, 0x20, 0x00, 0x33, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x33, 0x33, 0x30, 0x00, 0x44, 0x44, 0x44, 0x00, 0x03, 0x33, 0x44, 0x40, 0x22, 0x00, 0x00, 0x00, 0x22, 0x04, 0x44, 0x00, 0x00, 0x22, 0x03, 0x33, 0x00, 0x22, 0x00, 0x00, 0x00, 0x00, 0x33, 0x03, 0xa3, 0x00, 0x33, 0x00, 0x00,
    0x00, 0x00, 0x44, 0x00, 0x02, 0x20, 0x00, 0x00, 0x00, 0x02, 0x20, 0x44, 0x00, 0x02, 0x20, 0x22, 0x03, 0x30, 0x02, 0x20, 0x22, 0x00, 0x02, 0x20, 0x22, 0x03, 0x30, 0x02, 0x20, 0x22, 0x00, 0x00, 0x00, 0x22, 0x03, 0x30, 0x00, 0x00, 0x22, 0x00, 0x44, 0x44, 0x22, 0x03, 0x30, 0x33, 0x30, 0x00, 0x00, 0x02, 0x22, 0x00, 0x00, 0x00, 0x33, 0x30, 0x00, 0x44, 0x42, 0x22, 0x00, 0x33, 0x33, 0x44, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x33, 0x33, 0x00, 0x00, 0x33, 0x03, 0x33, 0x03, 0x30, 0x00, 0x00, 0x00, 0x00, 0x33, 0x03, 0xa3, 0x03, 0x30, 0x00, 0x00,
    0x00, 0x22, 0x03, 0x30, 0x00, 0x00, 0x04, 0x40, 0x00, 0x00, 0x22, 0x03, 0x30, 0x22, 0x22, 0x24, 0x40, 0x00, 0x00, 0x00, 0x03, 0x30, 0x22, 0x22, 0x24, 0x40, 0x00, 0x00, 0x33, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x33, 0x00, 0x33, 0x02, 0x22, 0x22, 0x22, 0x22, 0x20, 0x33, 0x44, 0x33, 0x00, 0x00, 0x00, 0x00, 0x22, 0x20, 0x33, 0x44, 0x33, 0x00, 0x44, 0x44, 0x40, 0x22, 0x20, 0x33, 0x00, 0x33, 0x00, 0x00, 0x00, 0x00, 0x22, 0x20, 0x00, 0x00, 0x00, 0x22, 0x03, 0x33, 0x00, 0x00, 0x44, 0x00, 0x00, 0x00, 0x22, 0x03, 0xa3, 0x00, 0x00, 0x44, 0x00,
    0x00, 0x02, 0x22, 0x00, 0x22, 0x20, 0x00, 0x00, 0x00, 0x00, 0x02, 0x22, 0x00, 0x22, 0x20, 0x44, 0x00, 0x00, 0x00, 0x02, 0x22, 0x00, 0x22, 0x20, 0x44, 0x01, 0x00, 0x33, 0x00, 0x00, 0x00, 0x22, 0x20, 0x44, 0x01, 0x00, 0x33, 0x00, 0x22, 0x22, 0x22, 0x20, 0x00, 0x01, 0x00, 0x00, 0x00, 0x22, 0x24, 0x42, 0x20, 0x00, 0x00, 0x00, 0x33, 0x33, 0x30, 0x00, 0x00, 0x00, 0x33, 0x33, 0x34, 0x44, 0x44, 0x40, 0x00, 0x00, 0x00, 0x33, 0x33, 0x34, 0x00, 0x00, 0x00, 0x03, 0x33, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xa3, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x03, 0x30, 0x00, 0x00, 0x00, 0x33, 0x00, 0x00, 0x00, 0x03, 0x30, 0x00, 0x00, 0x00, 0x33, 0x00, 0x00, 0x11, 0x10, 0x02, 0x22, 0x22, 0x22, 0x00, 0x01, 0x11, 0x11, 0x10, 0x02, 0x22, 0x22, 0x22, 0x00, 0x01, 0x11, 0x11, 0x10, 0x03, 0x33, 0x33, 0x33, 0x00, 0x01, 0x11, 0x11, 0x10, 0x03, 0x33, 0x33, 0x33, 0x00, 0x01, 0x11, 0x11, 0x12, 0x20, 0x03, 0x33, 0x00, 0x22, 0x01, 0x11, 0x44, 0x42, 0x20, 0x00, 0x00, 0x00, 0x22, 0x04, 0x44, 0x00, 0x02, 0x20, 0x03, 0x33, 0x00, 0x22, 0x00, 0x00, 0x00, 0x02, 0x20, 0x03, 0xa3, 0x00, 0x22, 0x00, 0x00,
    0x00, 0x02, 0x40, 0x00, 0x00, 0x44, 0x40, 0x00, 0x00, 0x00, 0x42, 0x40, 0x00, 0x00, 0x00, 0x00, 0x22, 0x00, 0x00, 0x42, 0x40, 0x44, 0x44, 0x04, 0x24, 0x22, 0x00, 0x22, 0x40, 0x00, 0x22, 0x22, 0x04, 0x24, 0x22, 0x00, 0x22, 0x40, 0x00, 0x44, 0x44, 0x04, 0x24, 0x22, 0x44, 0x00, 0x00, 0x22, 0x22, 0x22, 0x24, 0x00, 0x00, 0x00, 0x44, 0x44, 0x24, 0x44, 0x42, 0x24, 0x44, 0x44, 0x00, 0x22, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x22, 0x00, 0x40, 0x03, 0x33, 0x00, 0x04, 0x04, 0x44, 0x22, 0x00, 0x40, 0x03, 0xa3, 0x00, 0x04, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x03, 0x00, 0x00, 0x00, 0x30, 0x20, 0x00, 0x03, 0x32, 0x03, 0x00, 0x00, 0x00, 0x30, 0x23, 0x30, 0x02, 0x22, 0x00, 0x02, 0x22, 0x20, 0x00, 0x22, 0x20, 0x00, 0x00, 0x00, 0x03, 0x33, 0x30, 0x00, 0x00, 0x00, 0x33, 0x00, 0x00, 0x42, 0x22, 0x24, 0x00, 0x00, 0x33, 0x33, 0x30, 0x00, 0x00, 0x44, 0x00, 0x00, 0x03, 0x33, 0x00, 0x33, 0x02, 0x00, 0x00, 0x00, 0x20, 0x33, 0x00, 0x00, 0x33, 0x02, 0x03, 0x33, 0x00, 0x20, 0x33, 0x00, 0x00, 0x33, 0x02, 0x03, 0xa3, 0x00, 0x20, 0x33, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x30, 0x00, 0x30, 0x00, 0x30, 0x00, 0x03, 0x43, 0x03, 0x43, 0x03, 0x43, 0x03, 0x43, 0x00, 0x00, 0x30, 0x00, 0x30, 0x00, 0x30, 0x00, 0x30, 0x00, 0x30, 0x00, 0x30, 0x00, 0x30, 0x00, 0x30, 0x00, 0x33, 0x44, 0x03, 0x43, 0x03, 0x43, 0x03, 0x43, 0x00, 0x44, 0x00, 0x00, 0x30, 0x00, 0x30, 0x00, 0x30, 0x00, 0x00, 0x03, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00, 0x33, 0x00, 0x03, 0x30, 0x22, 0x03, 0x33, 0x02, 0x20, 0x33, 0x00, 0x00, 0x00, 0x22, 0x03, 0xa3, 0x02, 0x20, 0x00, 0x00,
    0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x02, 0x00, 0x01, 0x11, 0x10, 0x00, 0x20, 0x00, 0x20, 0x02, 0x00, 0x11, 0x44, 0x11, 0x00, 0x20, 0x02, 0x22, 0x00, 0x01, 0x10, 0x11, 0x01, 0x10, 0x00, 0x22, 0x22, 0x20, 0x01, 0x10, 0x11, 0x01, 0x10, 0x02, 0x22, 0x22, 0x20, 0x01, 0x11, 0x11, 0x11, 0x10, 0x02, 0x22, 0x22, 0x00, 0x00, 0x33, 0x00, 0x33, 0x00, 0x00, 0x22, 0x20, 0x44, 0x03, 0x30, 0x00, 0x03, 0x30, 0x44, 0x02, 0x00, 0x00, 0x00, 0x03, 0x33, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xa3, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x33, 0x00, 0x00, 0x00, 0x33, 0x00, 0x00, 0x22, 0x20, 0x33, 0x00, 0x00, 0x00, 0x33, 0x02, 0x22, 0x22, 0x20, 0x33, 0x02, 0x22, 0x20, 0x33, 0x02, 0x22, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x33, 0x04, 0x04, 0x44, 0x40, 0x40, 0x33, 0x30, 0x00, 0x03, 0x04, 0x00, 0x00, 0x00, 0x40, 0x30, 0x00, 0x33, 0x03, 0x04, 0x40, 0x00, 0x04, 0x40, 0x30, 0x33, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x03, 0x33, 0x00, 0x03, 0x33, 0x00, 0x00, 0x33, 0x30, 0x00, 0x00, 0x00, 0x03, 0xa3, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x03, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x03, 0x00, 0x00, 0x33, 0x30, 0x30, 0x01, 0x40, 0x00, 0x40, 0x00, 0x00, 0x33, 0x33, 0x30, 0x20, 0x00, 0x00, 0x00, 0x20, 0x20, 0x00, 0x33, 0x30, 0x22, 0x24, 0x44, 0x22, 0x20, 0x22, 0x00, 0x00, 0x00, 0x02, 0x23, 0x33, 0x22, 0x00, 0x22, 0x00, 0x02, 0x30, 0x00, 0x00, 0x00, 0x00, 0x03, 0x03, 0x00, 0x02, 0x30, 0x03, 0x03, 0x33, 0x03, 0x03, 0x03, 0x00, 0x02, 0x30, 0x03, 0x03, 0xa3, 0x03, 0x03, 0x03, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x02, 0x22, 0x20, 0x00, 0x30, 0x00, 0x00, 0x03, 0x00, 0x02, 0x22, 0x20, 0x00, 0x30, 0x00, 0x20, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x02, 0x22, 0x00, 0x02, 0x24, 0x44, 0x42, 0x20, 0x00, 0x22, 0x00, 0x03, 0x30, 0x00, 0x00, 0x00, 0x03, 0x30, 0x00, 0x41, 0x13, 0x31, 0x11, 0x11, 0x11, 0x13, 0x31, 0x14, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x11, 0x03, 0x33, 0x00, 0x11, 0x00, 0x01, 0x10, 0x00, 0x11, 0x03, 0xa3, 0x00, 0x11, 0x00, 0x01,
    0x00, 0x11, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x00, 0x33, 0x30, 0x02, 0x00, 0x00, 0x00, 0x03, 0x33, 0x33, 0x00, 0x03, 0x02, 0x44, 0x11, 0x10, 0x00, 0x00, 0x03, 0x33, 0x33, 0x02, 0x00, 0x11, 0x10, 0x04, 0x40, 0x30, 0x00, 0x00, 0x30, 0x00, 0x11, 0x11, 0x10, 0x03, 0x03, 0x03, 0x03, 0x03, 0x00, 0x00, 0x01, 0x10, 0x00, 0x33, 0x33, 0x33, 0x30, 0x03, 0x33, 0x33, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x33, 0x00, 0x00, 0x44, 0x44, 0x00, 0x00, 0x00, 0x03, 0xa3, 0x00, 0x00, 0x00, 0x00,
    0x02, 0x00, 0x22, 0x00, 0x00, 0x02, 0x20, 0x02, 0x00, 0x00, 0x00, 0x22, 0x02, 0x22, 0x02, 0x20, 0x00, 0x00, 0x00, 0x00, 0x22, 0x00, 0x00, 0x02, 0x20, 0x00, 0x00, 0x22, 0x02, 0x20, 0x02, 0x22, 0x00, 0x22, 0x00, 0x22, 0x22, 0x02, 0x20, 0x02, 0x22, 0x00, 0x22, 0x00, 0x22, 0x22, 0x02, 0x20, 0x00, 0x40, 0x00, 0x22, 0x00, 0x22, 0x22, 0x33, 0x30, 0x00, 0x00, 0x00, 0x33, 0x30, 0x22, 0x22, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x22, 0x00, 0x00, 0x03, 0x03, 0x33, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x03, 0xa3, 0x03, 0x00, 0x00, 0x00,
    0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x22, 0x02, 0x00, 0x11, 0x00, 0x00, 0x22, 0x22, 0x20, 0x22, 0x00, 0x00, 0x11, 0x00, 0x00, 0x22, 0x22, 0x20, 0x22, 0x03, 0x33, 0x11, 0x02, 0x20, 0x00, 0x00, 0x00, 0x22, 0x00, 0x00, 0x00, 0x02, 0x20, 0x04, 0x43, 0x30, 0x00, 0x00, 0x00, 0x00, 0x02, 0x20, 0x04, 0x43, 0x30, 0x00, 0x22, 0x22, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x22, 0x22, 0x00, 0x11, 0x00, 0x03, 0x33, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x03, 0xa3, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x01, 0x10, 0x00, 0x00, 0x00, 0x03, 0x00, 0x04, 0x00, 0x01, 0x10, 0x00, 0x33, 0x33, 0x03, 0x30, 0x04, 0x00, 0x01, 0x10, 0x00, 0x00, 0x33, 0x03, 0x30, 0x04, 0x00, 0x00, 0x00, 0x11, 0x00, 0x33, 0x00, 0x00, 0x04, 0x03, 0x34, 0x00, 0x00, 0x00, 0x33, 0x00, 0x44, 0x44, 0x01, 0x14, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x04, 0x44, 0x11, 0x10, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x10, 0x30, 0x03, 0x33, 0x00, 0x32, 0x20, 0x00, 0x00, 0x00, 0x30, 0x03, 0xa3, 0x00, 0x32, 0x20, 0x00,
    0x04, 0x30, 0x02, 0x20, 0x00, 0x22, 0x00, 0x43, 0x00, 0x04, 0x30, 0x02, 0x20, 0x00, 0x22, 0x00, 0x43, 0x00, 0x00, 0x30, 0x02, 0x20, 0x00, 0x22, 0x00, 0x03, 0x00, 0x00, 0x30, 0x00, 0x00, 0x20, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x22, 0x22, 0x20, 0x04, 0x44, 0x00, 0x02, 0x22, 0x22, 0x22, 0x22, 0x23, 0x30, 0x00, 0x03, 0x32, 0x22, 0x22, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x20, 0x03, 0x33, 0x00, 0x02, 0x20, 0x00, 0x00, 0x02, 0x20, 0x03, 0xa3, 0x00, 0x02, 0x20, 0x00,
    0x00, 0x03, 0x30, 0x00, 0x00, 0x00, 0x03, 0x30, 0x00, 0x00, 0x03, 0x30, 0x30, 0x00, 0x30, 0x03, 0x30, 0x00, 0x02, 0x00, 0x00, 0x30, 0x00, 0x30, 0x00, 0x00, 0x20, 0x22, 0x00, 0x00, 0x33, 0x33, 0x30, 0x00, 0x00, 0x22, 0x22, 0x00, 0x30, 0x03, 0x33, 0x00, 0x03, 0x00, 0x22, 0x00, 0x03, 0x30, 0x00, 0x30, 0x00, 0x03, 0x33, 0x00, 0x33, 0x33, 0x30, 0x00, 0x40, 0x00, 0x03, 0x33, 0x33, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x03, 0x33, 0x00, 0x00, 0x10, 0x00, 0x00, 0x01, 0x10, 0x03, 0xa3, 0x00, 0x01, 0x10, 0x00
};

void SyncDelay(char ms)
{
    ms = ms * 256 / 1000;
    while((Getms()-ms0&0xff)<ms);
}

void Wait_ReleaseKey()
{
    Inkey();
    while(CheckKey(128));
}

void Wait_ContinueKey()
{
    Wait_ReleaseKey();
    //for (;;)
    {
        key = getchar();/*
        if (key == 13 || key == 27)
        {
            break;
        }*/
    }
    Wait_ReleaseKey();
}

void DrawBlank(char x, char y)
{
    Block(x, y, x+7, y+7, 0);
}

void DrawMenuBorder(char type)
{
    if (type == 0)
        ClearScreen();
    Block(10,Y0+0, 151,Y0+6, 0x01);
    Block(11,Y0+75, 151,Y0+79, 0x01);
    WriteBlock(0,Y0+74, 11,6, 0x01, bmp_menu_x0y1);
    WriteBlock(55,Y0+2, 47,15, 0x01, bmp_menu_title);
    if (type != 0)
        return;
    Block(153,Y0+13, 159,Y0+71, 0x01);
    Block(0,Y0+10, 6,Y0+73, 0x01);
    WriteBlock(0,Y0+0, 10,10, 0x01, bmp_menu_x0y0);
    WriteBlock(152,Y0+0, 8,13, 0x01, bmp_menu_x1y0);
    WriteBlock(152,Y0+72, 8,8, 0x01, bmp_menu_x1y1);
    
}

void DrawMenuMain(int x, int y)
{
    y = y + 15;
    // menu_main_top
    Block(x+7, y, x+38, y+1, 0x01);
    Line(x+37, y+2, x+38, y+2, 0x41);
    Line(x+36, y+3, x+39, y+3, 0x41);
    Line(x+35, y+4, x+36, y+4, 0x41);
    Line(x+38, y+4, x+40, y+4, 0x41);
    // menu_main_left1
    Block(x+7, y+12, x+23, y+13, 0x01);
    Block(x+24, y+11, x+30, y+15, 0x01);
    Line(x+26, y+13, x+27, y+13, 0x40);
    // menu_main_left2
    Block(x+7, y+23, x+15, y+24, 0x01);
    Block(x+14, y+25, x+15, y+37, 0x01);
    Block(x+16, y+25, x+25, y+26, 0x01);
    Block(x+26, y+24, x+30, y+27, 0x01);
    Line(x+27, y+25, x+29, y+25, 0x40);
    // menu_main_left3
    Block(x+16, y+36, x+21, y+37, 0x01);
    Block(x+22, y+33, x+25, y+38, 0x01);
    Line(x+23, y+34, x+24, y+34, 0x40);
    Block(x+25, y+32, x+30, y+39, 0x01);
    Line(x+26, y+33, x+29, y+33, 0x40);
    Line(x+26, y+36, x+29, y+36, 0x40);
    // menu_main_left4
    Block(x+7, y+49, x+23, y+50, 0x01);
    Block(x+24, y+48, x+27, y+51, 0x01);
    Line(x+25, y+49, x+26, y+49, 0x40);
    Block(x+28, y+46, x+30, y+53, 0x01);
    Line(x+29, y+48, x+30, y+48, 0x40);
    Line(x+27, y+47, x+27, y+52, 0x41);
    //
    x = x + 31;
    Rectangle(x, y+5, x+113, y+56, 2);
    Rectangle(x, y+5, x+111, y+54, 1);
    Rectangle(x+1, y+6, x+110, y+53, 2);
    Rectangle(x+2, y+7, x+109, y+52, 2);
    Point(x+112, y+55, 0x41);
}

void DrawText(int x, int y, addr str)
{
    if (y < LCD_H-12)
    {
        TextOut(x, y, str, 0x01);
    }
}

void DrawMenuTextClear()
{
    Block(31+3, 15+8+Y0, 31+108, 15+51+Y0, 0);
}


void DrawMenuText(int x, int y, char type)
{
    char str[3];
    if (type == 0)
    {
        DrawText(x+36, y+24, "ʼս Ϸ趨");
        DrawText(x+36, y+38, "ȡ ƬԤ");
        DrawText(x+36, y+52, "սֲ ˳ս");
    }
    if (type == 1)
    {
        DrawText(x+50, y+30, "̹ȫ!");
        DrawText(x+52, y+46, "ź,!");
    }
    if (type == 2)
    {
        if (game.mapMode == 0)
        {
            DrawText(x+57, y+31, "[׼ͼ]");
        }
        else
        {
            DrawText(x+57, y+31, "[չͼ]");
        }
        str[2] = 0;
        str[1] = '0' + (game.curRound + 1) % 10;
        str[0] = '0' + (game.curRound + 1) / 10;
        DrawText(x+45, y+46, "׼  ");
        DrawText(x+105, y+46, str);
    }
    if (type == 3)
    {
        DrawText(x+50, y+30, "ʤ!");
        DrawText(x+52, y+46, ",ף!");
    }
}

void ShowMenu(char text_type)
{
    DrawMenuBorder(0);

    for (i = 0; i <= 64; i = i + 8)
    {
        ms0 = Getms();
        Block(7, Y0+79-i, 144, Y0+74, 0);
        DrawMenuMain(0, Y0+64-i);
        DrawMenuText(0, Y0+64-i, text_type);
        DrawMenuBorder(1);
        if (LCD_H > 80)
        {
            Block(0, Y0+80, LCD_W-1, LCD_H-1, 0);
        }
        Refresh();
        SyncDelay(MENU_DELAY*2);
    }
    for (i = 0; i <= 14; i = i + 2)
    {
        ms0 = Getms();
        Block(111, Y0+7, 142, Y0+19, 0);
        WriteBlock(111, i-7+Y0, 32, 13, 0x3, bmp_menu_top);
        if (Y0 > 0)
        {
            Block(111, 0, 142, Y0-1, 0);
        }
        Refresh();
        SyncDelay(MENU_DELAY);
    }
    for (i = 154; i >= 145; i = i - 3)
    {
        ms0 = Getms();
        Block(145, Y0+32, 152, Y0+63, 0);
        WriteBlock(i, Y0+32, 8, 32, 0x03, bmp_menu_right);
        Refresh();
        SyncDelay(MENU_DELAY);
    }
}

void HideMenu(char text_type)
{
    for (i = 145; i <= 154; i = i + 3)
    {
        ms0 = Getms();
        Block(145, 32+Y0, 152, 63+Y0, 0);
        WriteBlock(i, 32+Y0, 8, 32, 0x03, bmp_menu_right);
        Refresh();
        SyncDelay(MENU_DELAY*2);
    }
    for (i = 0; i <= 14; i = i + 2)
    {
        ms0 = Getms();
        Block(111, Y0+7, 142, 19+Y0, 0);
        WriteBlock(111, Y0+7-i, 32, 13, 0x03, bmp_menu_top);
        if (Y0 > 0)
        {
            Block(111, 0, 142, Y0-1, 0);
        }
        Refresh();
        SyncDelay(MENU_DELAY);
    }
    for (i = 0; i <= 64; i = i + 8)
    {
        ms0 = Getms();
        Block(7, i+7+Y0, 144, 74+Y0, 0);
        DrawMenuMain(0, i+Y0);
        DrawMenuText(0, i+Y0, text_type);
        DrawMenuBorder(1);
        if (LCD_H > 80)
        {
            Block(0, Y0+80, LCD_W-1, LCD_H-1, 0);
        }
        Refresh();
        SyncDelay(MENU_DELAY*2);
    }
}

void DrawInfo()
{
    char str_life[2];
    Rectangle(145, 0, LCD_W, LCD_H, 1);
    Block(146, 1, LCD_W-1, LCD_H-1, 0);
    //
    Rectangle(149, 12, 156, 54, 1);
    WriteBlock(149, 3, 8, 8, 1, bmp_enemy[0][0]);
    for (j = 0; j < game.lastEnemy; j++)
    {
        Line(151, j*2+14, 154, j*2+14, 0x41);
    }

    Line(145, Y0+56, 159, Y0+56, 0x41);
    WriteBlock(149, LCD_H-22, 8, 8, 1, bmp_player[0]);
    str_life[1] = 0;
    str_life[0] = '0' + game.pLife;
    TextOut(150, LCD_H-13, str_life, 1);
}

void DrawDialog()
{
    Box(20, Y0+24, 139, Y0+55, 0, 0x00);
    Box(21, Y0+25, 138, Y0+54, 1, 0x01);
    Box(25, Y0+29, 134, Y0+50, 1, 0x00);
    Line(21,Y0+25, 25,Y0+29, 0x00);
    Line(138,Y0+25, 134,Y0+29, 0x00);
    Line(21,Y0+54, 25,Y0+50, 0x00);
    Line(138,Y0+54, 134,Y0+50, 0x00);
}

//////Ƴ////////////////////
void DrawSence()
{
    char x, y;
    ClearScreen();
    Refresh();
    DrawDialog();
    WriteBlock(58, Y0+32, 50, 10, 0x41, bmp_loading);
    Rectangle(28, Y0+43, 131, Y0+49, 0x41);
    //ϷҪĳ
    for (y = 0; y < MAP_H/8; y++)
    {
        ms0 = Getms();
        for (x = 0; x < MAP_W/8; x++)
        {
            WriteBlock(x*8, y*8, 8, 8, 1, bmp_tile[sence[y][x]]);
        }
        if (y < 10)
        {
            Block(30+y*10, Y0+45, 39+y*10, Y0+47, 0x41);
            SyncDelay(20);
        }
    }
    WriteBlock(64, MAP_H-8, 8, 8, 1, bmp_item[0]);
    //ϷҪĳ
    DrawInfo();
}

// ļ
void SaveConfig()
{
    char fp;
    if ((fp = fopen("/LavaData/TankRec.dat", "w+")) != 0)
    {
        putc(level, fp);
        putc(delaylevel, fp);
        putc(game.mapMode, fp);
        fclose(fp);
    }
}

// ȡļ
void ReadConfig()
{
    char fp;
    // ȡļ
    if ((fp = fopen("/LavaData/TankRec.dat", "r")) != 0)
    {
        level = getc(fp);
        delaylevel = getc(fp);
        game.mapMode = getc(fp);
        fclose(fp);
    }
    // ޴浵ֵ
    else
    {
        level = 1;
        delaylevel = 3; // 0~7
        game.mapMode = 0;
    }
    // ȡΧͼ
    if ((fp = fopen("/LavaData/TankMap.dat", "r")) != 0)
    {
        rewind(fp);
        ext_roundmax = getc(fp);
        fclose(fp);
    }
    else
    {
        game.mapMode = 0;
        ext_roundmax = 255;
    }
}

int GameLoad(char mode)
{
    char fp;
    char ch;

    if (mode == 1)
    {
        DrawDialog();
        TextOut(28, Y0+34, "? Y- N-", 0x41);
        Wait_ReleaseKey();
        for (;;)
        {
            ch = getchar();
            if (ch == 'y' || ch == 13 || ch == KEY_SHOOT)
            {
                break;
            }
            if (ch == 'n' || ch == 27 || ch == KEY_PAUSE)
            {
                return -1;
            }
        }
    }

    if ((fp = fopen("/LavaData/TankSave.dat", "r")) != 0)
    {
        rewind(fp);
        fread(&sence, 1, sizeof(sence), fp);
        fread(&en, 1, sizeof(en), fp);      //
        fread(&eg, 1, sizeof(eg), fp);      //ӵ
        fread(&pg, 1, sizeof(pg), fp);      //ӵ
        fread(&game, 1, sizeof(game), fp);  //Ϸ
        fread(&bomb, 1, sizeof(bomb), fp);  //ը
        fread(&item, 1, sizeof(item), fp);  //Ʒ
        fclose(fp);
        return 0;
    }
    // 
    return -1;
}

int GameSave()
{
    char fp;
    char ch;

    DrawDialog();
    TextOut(28, Y0+34, "? Y- N-", 0x41);
    Wait_ReleaseKey();
    for (;;)
    {
        ch = getchar();
        if (ch == 'y' || ch == 13 || ch == KEY_SHOOT)
        {
            break;
        }
        if (ch == 'n' || ch == 27 || ch == KEY_PAUSE)
        {
            return -1;
        }
    }

    DrawDialog();
    TextOut(28, Y0+34, "ڴ,ȴ..", 0x41);

    if ((fp = fopen("/LavaData/TankSave.dat", "w+")) != 0)
    {
        rewind(fp);
        //泡
        fwrite(&sence, 1, sizeof(sence), fp);
        fwrite(&en, 1, sizeof(en), fp);     //
        fwrite(&eg, 1, sizeof(eg), fp);     //ӵ
        fwrite(&pg, 1, sizeof(pg), fp);     //ӵ
        fwrite(&game, 1, sizeof(game), fp); //Ϸ
        fwrite(&bomb, 1, sizeof(bomb), fp); //ը
        fwrite(&item, 1, sizeof(item), fp); //Ʒ
        fclose(fp);
        return 0;
    }
    //
    return -1;
}

void GamePause()
{
    DrawDialog();
    TextOut(28, Y0+32, "PAUSE", 0xC1);
    TextOut(70, Y0+34, "", 0x41);
    Wait_ContinueKey();
}

void GameOver()
{
    ShowMenu(1);
    //WriteBlock(0, 0, 160, 80, 1, bmp_menu);
    //TextOut(50, 30, "̹ȫ!", 1);
    //TextOut(52, 46, "ź,!", 1);
    Refresh();
    Wait_ContinueKey();
    HideMenu(1);
}

int RoundPass()
{
    if (++game.curRound <= game.maxRound)
    {
        if (game.mapMode != 0 && ext_roundmax == 255)
        {
            game.mapMode = 0;
            game.maxRound = sys_roundmax;
            game.curRound = 0;
        }
        ShowMenu(2);
        //WriteBlock(0, 0, 160, 80, 1, bmp_menu);
        //sprintf(r, "׼%d", game.curRound + 1);
        //TextOut(45, 40, r, 1);
        Refresh();
        Wait_ContinueKey();
        HideMenu(2);
        return 0;
    }
    ShowMenu(3);
    //WriteBlock(0, 0, 160, 80, 1, bmp_menu);
    //TextOut(50, 30, "ʤ!", 1);
    //TextOut(52, 46, ",ף!", 1);
    Refresh();
    Wait_ContinueKey();
    HideMenu(3);
    return 1;
}

int RoundFirst()
{
    char ch;
    if (game.mapMode == 0 || ext_roundmax==255)
    {
        game.mapMode = 0;
        game.maxRound = sys_roundmax;
    }
    else
    {
        game.maxRound = ext_roundmax;
    }
    for (;;)
    {
        if (game.curRound > game.maxRound)
        {
            game.curRound = 0;
        }
        //WriteBlock(0, 0, 160, 80, 1, bmp_menu);
        DrawMenuTextClear();
        DrawMenuText(0, Y0+0, 2);
        Refresh();
        ch = getchar();
        if (ch == KEY_UP || ch == KEY_LEFT)
        {
            if (game.curRound > 0)
            {
                game.curRound--;
            }
            else
            {
                game.curRound = game.maxRound;
            }
        }
        if (ch == KEY_DOWN || ch == KEY_RIGHT)
        {
            game.curRound++;
        }
        if (ch == 27 || ch == KEY_PAUSE)
        {
            return -1;
        }
        if (ch == 13 || ch == KEY_SHOOT)
        {
            return 0;
        }
    }
}

void LoadSence()
{
    addr dst, src;
    char fp;

    if (game.mapMode != 0)
    {
        if ((fp = fopen("/LavaData/TankMap.dat", "r")) != 0)
        {
            rewind(fp);
            game.maxRound = ext_roundmax = getc(fp);
            fseek(fp, game.curRound * 180 + 1, 0);
            fread(sence, 1, 180, fp);
            fclose(fp);
        }
        else
        {
            game.mapMode = 0;
            game.maxRound = sys_roundmax;
        }
    }
    if (game.mapMode == 0)
    {
        if (game.curRound > game.maxRound)
        {
            game.curRound = game.maxRound;
        }
        src = map[game.curRound];
        dst = sence;
        for (i = 0; i < 180/2; i++)
        {
            *dst++ = *src>>4;
            *dst++ = *src&15;
            src++;
        }
    }
    if (MAP_H > 80)
    {
        src = sence;
        memmove(MAP_W/8*4+src, MAP_W/8*2+src, sizeof(sence)-MAP_W/8*4);
        memmove(MAP_W/8*2+src, MAP_W/8*1+src, MAP_W/8*2);
    }
}

//趨////////////////////
void SetItem(char x, char y)
{
    if (rand() % 5 == 0)
    {
        if (item.state == 1)
        {
            DrawBlank(item.x, item.y);
        }
        item.x = x;
        item.y = y;
        item.state = 1;
        item.time = ITEM_TIME;
        item.style = rand() % 6;
    }
}

///////趨ըͼ
void SetBomb(char x, char y)
{
    for (j = 0; j < BOMB_MAX; j++)
    {
        if (bomb[j].state == 0)
        {
            bomb[j].state = 1;
            bomb[j].id = 0;
            bomb[j].x = x;
            bomb[j].y = y;
            break;
        }
    }
}

//////ײ

char GunHitBlock(char x, char y, char gid, char player, char arrow)
{
    char tempvalue;
    tempvalue = 0;
    if (x < 0 || y < 0 || x > MAP_W-8 || y > MAP_H-8)
    {
        tempvalue = 255;
    }
    else
    {
        if (arrow == 1)//
        {
            y = y + 4;
        }
        if (arrow == 3)//
        {
            x = x + 4;
        }
        Tx = x >> 3;
        Ty = y >> 3;
        if (Tx >= 0 && Tx < MAP_W/8 && Ty >= 0 && Ty < MAP_H/8)
        {
            tempvalue = sence[Ty][Tx];
        }
    }

    if (tempvalue != 0)
    {
        if (tempvalue == 1 || tempvalue == 2)
        {
            sence[Ty][Tx] =  0;
            SetBomb(Tx *8, Ty *8);
        }
        if (tempvalue == 3)
        {
            if (player == 1 && game.pGun >= 2)
            {
                sence[Ty][Tx] = 0;
                SetBomb(Tx *8, Ty *8);
            }
            else
            {
                sence[Ty][Tx] = 1;
                WriteBlock(Tx *8, Ty *8, 8, 8, 1, bmp_tile[1]);
            }
        }
        if (tempvalue == 4)
        {
            if (player == 0)
            {
                sence[Ty][Tx] = 4;
            }
            if (player == 1 && game.pGun >= 3)
            {
                sence[Ty][Tx] = 0;
                SetBomb(Tx *8, Ty *8);
            }
            else
            {
                WriteBlock(Tx *8, Ty *8, 8, 8, 1, bmp_tile[4]);
            }
        }
        if (tempvalue == 10)
        {
            if (player == 0)
            {
                game.superTime = 0;
                sence[MAP_H/8-1][8] = 0;
                SetBomb(64, MAP_H-8);
                game.deadDelay = SHOW_DEAD_TIME;
                SetBomb(game.px, game.py);
            }
            else
            {
                WriteBlock(64, MAP_H-8, 8, 8, 1, bmp_item[0]);
            }
        }
        tempvalue = 255;
    }
    if (tempvalue == 255)
    {
        if (player == 0)
        {
            eg[gid].state = 0;
        }
        else
        {
            pg.state = 0;
        }
    }
    return tempvalue;
}

char CheckBlock(char X, char Y, char Xd, char Yd, char IsMan, char eid)
{
    char XOffset, YOffset;
    char over, flag;

    if (IsMan == 0 && game.pauseTime > 0)
    {
        return 0;
    }

    if (Xd > 0 && Xd < MAP_W)
    {
        XOffset = 1;
    }
    else
    {
        XOffset = 0;
    }
    //
    if (Yd > 0 && Yd < MAP_H)
    {
        YOffset = 1;
    }
    else
    {
        YOffset = 0;
    }
    Tx = X + Xd;
    Ty = Y + Yd;
    over = 0;
    if (Tx > MAP_W) // <0
    {
        Tx = 0;
        over = 20;
    }
    else
    if (Tx > MAP_W - 8)
    {
        Tx = MAP_W - 8;
        over = 20;
    }
    if (Ty > MAP_H) // <0
    {
        Ty = 0;
        over = 20;
    }
    else
    if (Ty > MAP_H - 8)
    {
        Ty = MAP_H - 8;
        over = 20;
    }

    flag = 0;
    if (Xd > MAP_W || Yd > MAP_H) //Xd<0 || Yd<0
    {
        flag = 1;
    }
    if (YOffset==1 && (Ty & 7) != 0)
    {
        flag = 1;
    }
    if (XOffset==1 && (Tx & 7) != 0)
    {
        flag = 1;
    }
    eblock = sence[(Ty >> 3) + YOffset][(Tx >> 3) + XOffset];
    if (eblock != 0 && eblock <= 50 && flag == 1)
    {
        Tx = X;
        Ty = Y;
    }

    //ϷôϷߵ̬
    if (IsMan == 1)
    {
        game.px = Tx;
        game.py = Ty;
    }
    //ǵô˵״̬
    if (IsMan == 0)
    {
        en[eid].x = Tx;
        en[eid].y = Ty;
    }
    if (over == 20)
    {
        eblock = over;
    }
    return eblock;
}

//  ˵
void SetEnemyArrow(char eid)
{
    char a;
    if (game.pauseTime > 0)
    {
        return;
    }
    a = rand() & 3;//%4
    en[eid].arrow = a;
    en[eid].xspeed = 0;
    en[eid].yspeed = 0;
    if (en[eid].style == 1)
    {
        if (a == 0)
        {
            en[eid].yspeed = -2;
        }
        if (a == 1)
        {
            en[eid].yspeed = 2;
        }
        if (a == 2)
        {
            en[eid].xspeed = -2;
        }
        if (a == 3)
        {
            en[eid].xspeed = 2;
        }
    }
    else
    {
        if (a == 0)
        {
            en[eid].yspeed = -1;
        }
        if (a == 1)
        {
            en[eid].yspeed = 1;
        }
        if (a == 2)
        {
            en[eid].xspeed = -1;
        }
        if (a == 3)
        {
            en[eid].xspeed = 1;
        }
    }
}

//趨˵ĳ
void SetEnemy(char one)
{
    char num;
    num = 10 - game.curRound * 8 / game.maxRound;
    for (i = 0; i < game.maxEnemy; i++)
    {
        if (game.lastEnemy > 0 && en[i].state == 0 && en[i].showtime == 0)
        {
            game.lastEnemy--;
            en[i].y = 0;
            en[i].x = enemyshowx[enemyshowid];
            if (++enemyshowid >= ENEMY_MAX)
            {
                enemyshowid = 0;
            }
            j = rand() % num;
            if (j == 0)
            {// 
                en[i].style = 2;
                en[i].life = 3;
                en[i].earrrnd = 22;               
            }
            else
            if (j == 1)
            {// 
                en[i].style = 1;
                en[i].life = 1;
                en[i].earrrnd = 18;
            }
            else
            {// ͨ
                en[i].style = 0;
                en[i].life = 1;
                en[i].earrrnd = 14;
            }
            en[i].sleep = 0xff;
            en[i].showtime = SHOW_TIME;
            SetEnemyArrow(i);
            if (one)
            {
                break;
            }
        }
    }
}

//趨˵ĳ
void SetPlayer()
{
    game.superTime = 140;
    game.px = 48;
    game.py = MAP_H-8;
    game.pMove = 0; //С˵ǰ״̬Ϊ˹״̬
    game.pState = 0; //С˵ǰ״̬Ϊֹͣ״̬
}

void NextRound()
{
    game.superTime = 0;
    game.pauseTime = 0;
    game.baseTime = 0;
    pg.state = 0;

    for (i = 0; i < ENEMY_SHOOT; i++)
    {
        eg[i].state = 0;

    }
    for (i = 0; i < BOMB_MAX; i++)
    {
        bomb[i].state = 0;
    }

    for (i = 0; i < ENEMY_MAX; i++)
    {
        en[i].state = 0;
        en[i].x = 0;
        en[i].y = 0;
        en[i].life = 0;
        en[i].xspeed = 0;
        en[i].yspeed = 0;
        en[i].showtime = 0;
    }

    game.lastEnemy = 20;
    enemyshowid = 0;
    item.state = 0;
    //
    LoadSence();
    DrawSence();
    SetPlayer();
    SetEnemy(0);
}

void CheckEnemy()
{
    if (game.passDelay > 0)
    {
        return;
    }
    /*if (game.lastEnemy > 0)
    {
        game.lastEnemy--;
    }*/
    DrawInfo();
    if (game.lastEnemy == 0)
    {
        if (en[0].state == 0 && en[1].state == 0 && en[2].state == 0 && en[0].showtime == 0 && en[1].showtime == 0 && en[2].showtime == 0)
        {
            game.passDelay = SHOW_PASS_TIME;
        }
    }
    else
    {
        SetEnemy(1);
    }
}

//ѷӵ
void PlayerShoot()
{
    char x, y;
    if (pg.state == 0)
    {
        x = game.px + (dxy[0+game.pState]);
        y = game.py + (dxy[2+game.pState]);
        if (x < MAP_W-4 && y < MAP_H-4)
        {
            pg.arrow = game.pState;
            pg.state = 1;
            pg.x = x;
            pg.y = y;
            pg.xspeed = dxy[0+game.pState];
            pg.yspeed = dxy[2+game.pState];
        }
    }
}

//˷ӵ
void EnemyShoot(char x, char y, char arrow)
{
    if (game.pauseTime > 0)
    {
        return ;
    }
    if (rand() % 3 == 1)
    {
        for (j = 0; j < ENEMY_SHOOT; j++)
        {
            if (eg[j].state == 0)
            {
                x = x + (dxy[0+arrow] << 1);
                y = y + (dxy[2+arrow] << 1);
                if (x < MAP_W-4 && y < MAP_H-4)
                {
                    eg[j].state = 1;
                    eg[j].arrow = arrow;
                    eg[j].x = x;
                    eg[j].y = y;
                    eg[j].xspeed = dxy[0+arrow];
                    eg[j].yspeed = dxy[2+arrow];
                    eg[j].sleep = 0;
                    break;
                }
            }
        }
    }
}

void SetSpeed()
{
    char move_speed;
    char delay_max;
    if (speed_level == 0)
    {
        move_speed = 2;
        delay_max = 30;     //NC1020
    }
    else
    if (speed_level == 1)
    {
        move_speed = 2;
        delay_max = 50;     //NC2000
    }
    else
    if (speed_level == 2)
    {
        move_speed = 2;
        delay_max = 30;     //NC3000
    }
    else
    if (speed_level == 3)
    {
        move_speed = 2;
        delay_max = 70;     // TI-CALC
    }
    else
    {
        move_speed = 2;
        delay_max = 80;     // PC
    }
    //
    if (delaylevel <= 3 || speed_level >= 3)
    {
        delaytime = delay_max - (delaylevel-0) * 10; // delaylevel: 0 ~ 7;
        MoveSpeed = move_speed;
    }
    else
    {
        delaytime = delay_max - (delaylevel-4) * 10;
        MoveSpeed = move_speed * 2;
    }
    //dxy[2] = MoveSpeed * -2;
    //dxy[3] = MoveSpeed * 2;
}

void TestSpeed()
{
    int n;
    char ms;
    n = 0;
    ms = Getms();
    while(Getms()==ms);
    ms = Getms();
    while(Getms()==ms)
    {
        n++;
    }
    ms = Getms() - ms;
    n = n / ms;
    if (n < 15)
    {
        speed_level = 0;
    }
    else
    if (n < 30)
    {
        speed_level = 1;
    }
    else
    if (n < 50)
    {
        speed_level = 2;
    }
    else
    if (n < 100)
    {
        speed_level = 3;
    }
    else
    {
        speed_level = 10;
    }
    SetSpeed();
}

void main()
{
    Inkey();
    //
    enemyshowx[0] = 0;
    enemyshowx[1] = 64;
    enemyshowx[2] = 136;
    sys_roundmax = sizeof(map)/(10*18/2) - 1;

    ClearScreen();
    Rectangle(5, Y0+20, 44, Y0+59, 1);
    WriteBlock(9, Y0+24, 32, 32, 1, bmp_wawa);
    TextOut(40, Y0+0, " Ʒ ", 2);
    TextOut(54, Y0+24, ":ʫŵ", 1);
    TextOut(54, Y0+44, "ԭ:", 1);
    TextOut(4, Y0+64, "Mail:haoxinli1234@163.com", 1);
    if (LCD_H > 80)
    {
        TextOut(4, Y0+77, "Mail:snoopyzzz@sina.com", 1);
    }
    Refresh();
    //
    MakeDir("/LavaData");
    ReadConfig();
    TestSpeed();
    //
    getchar();
    //
    ClearScreen();
    WriteBlock(0, Y0+0, 160, 80, 1, bmp_splash);
    Refresh();
    getchar();
 
newgame:
    game.curRound = 0;
    game.pLife = 3;
    game.pGun = 1;
    optionid = 0;
    //Ϸ˵
MAIN_MENU:
    select = 0;
    ShowMenu(0);
    Wait_ReleaseKey();
    for (;;)
    {
        i = 35 + 54*(select&1);
        j = Y0 + 23 + 14*(select/2);
        Block(i, j, i+49, j+12, 2);
        Refresh();
        Block(i, j, i+49, j+12, 2);

        key = getchar();
        if (key == KEY_LEFT)
        {
            if (select > 0)
            {
                select--;
            }
            else
            {
                select = 5;
            }
        }
        if (key == KEY_RIGHT)
        {
            if (select < 5)
            {
                select++;
            }
            else
            {
                select = 0;
            }
        }
        if (key == KEY_UP)
        {
            if (select >= 2)
            {
                select = select - 2;
            }
            else
            {
                select = select + 4;
            }
        }
        if (key == KEY_DOWN)
        {
            if (select <= 3)
            {
                select = select + 2;
            }
            else
            {
                select = select - 4;
            }
        }
        if (key == 27 || key == KEY_PAUSE)
        {
            select = 5;
            break;
        }
        if (key == 13 || key == KEY_SHOOT)
        {
            break;
        }
    }
    ///////Ϸ˵

    if (select == 5)
    {
        ClearScreen();
        TextOut(38, Y0+20, "л!", 1);
        TextOut(12, Y0+45, "ڴܵĸƷ!", 1);
        TextOut(32, Y0+65, "밴˳!", 1);
        Refresh();
        getchar();
        exit(0);
    }
    if (select == 1)
    {
        for (;;)
        {
            //WriteBlock(0, 0, 160, 80, 1, bmp_menu);
            DrawMenuTextClear();
            TextOut(48, Y0+25, "Ѷ", 1);
            TextOut(48, Y0+40, "ٶ", 1);
            TextOut(48, Y0+54, "", 1);
            
            TextOut(80, Y0+25, "", 2-level);
            TextOut(110,Y0+25, "", 1+level);
            
            TextOut(80, Y0+54, "׼", 2-game.mapMode);
            TextOut(110,Y0+54, "չ", 1+game.mapMode);

            Rectangle(80, Y0+40, 133, Y0+50, 1);
            Block(82, Y0+42, delaylevel*7+82, Y0+48, 1);
            WriteBlock(38, Y0+27+optionid * 15, 8, 8, 1, gif_show[1]);

            Refresh();

            key = getchar();

            if (key == KEY_LEFT)
            {
                if (optionid == 0)
                {
                    level = 0;
                    game.maxEnemy = 2;
                }
                if (optionid == 1)
                {
                    if (delaylevel > 0)
                    {
                        delaylevel--;
                        SetSpeed();
                    }
                }
                if (optionid == 2)
                {
                    game.mapMode = 0;
                }
            }
            if (key == KEY_RIGHT)
            {
                if (optionid == 0)
                {
                    level = 1;
                    game.maxEnemy = 3;
                }
                if (optionid == 1)
                {
                    if (delaylevel < 7)
                    {
                        delaylevel++;
                        SetSpeed();
                    }
                }
                if (optionid == 2)
                {
                    if (ext_roundmax != 255)
                    {
                        game.mapMode = 1;
                    }
                }
            }
            if (key == KEY_UP)
            {
                if (optionid > 0)
                {
                    optionid--;
                }
            }
            if (key == KEY_DOWN)
            {
                if (optionid < 2)
                {
                    optionid++;
                }
            }
            if (key == 27 || key == 13 || key == KEY_SHOOT)
            {
                HideMenu(-1);
                SaveConfig();
                goto MAIN_MENU;
            }
        }
    }
    ///////Ϸ趨
    if (select == 3)
    {
        HideMenu(0);
        DrawMenuBorder(0);
        TextOut(8, Y0+20, "        ը", 1);
        TextOut(8, Y0+34, "  ܵһ!", 1);
        TextOut(8, Y0+48, "ֲFCͬƷ,ս", 1);
        TextOut(8, Y0+62, "Lavaٶȼ,ڴ!", 1);
        Refresh();
        getchar();

        WriteBlock(0, Y0+0, 160, 80, 1, bmp_bomman);
        Refresh();
        getchar();
        goto MAIN_MENU;
    }
    if (select == 4)
    {
        HideMenu(0);
        DrawMenuBorder(0);
        TextOut(8, Y0+20, "ӭָⳡս", 1);
        TextOut(8, Y0+34, "ָǿ̹", 1);
        TextOut(8, Y0+48, "[] źǵ", 1);
        TextOut(8, Y0+62, "عõ鱨!", 1);
        Refresh();
        if (getchar() == 27)
        {
            goto MAIN_MENU;
        }

        DrawMenuBorder(0);
        WriteBlock(22, Y0+22, 8, 8, 1, bmp_player[0]);
        TextOut(32, Y0+20, " ο̹", 1);
        TextOut(8, Y0+34, "ͨϵķ", 1);
        TextOut(8, Y0+48, "̹,[Z]", 1);
        TextOut(8, Y0+62, "̹˿!", 1);
        Refresh();
        if (getchar() == 27)
        {
            goto MAIN_MENU;
        }

        DrawMenuBorder(0);
        WriteBlock(22, Y0+22, 8, 8, 1, bmp_item[0]);
        TextOut(32, Y0+20, " ", 1);
        TextOut(8, Y0+34, "ԮҷĻ", 1);
        TextOut(8, Y0+48, "һʱ䷶Χܵ", 1);
        TextOut(8, Y0+62, "ǿ޵б!", 1);
        Refresh();
        if (getchar() == 27)
        {
            goto MAIN_MENU;
        }

        DrawMenuBorder(0);
        WriteBlock(22, Y0+22, 8, 8, 1, bmp_item[1]);
        TextOut(32, Y0+20, "    ˵", 1);
        TextOut(8, Y0+34, "ҷĺõ", 1);
        TextOut(8, Y0+48, "Ͷ뵽սս", 1);
        TextOut(8, Y0+62, "λܵԵĴ!", 1);
        Refresh();
        if (getchar() == 27)
        {
            goto MAIN_MENU;
        }

        DrawMenuBorder(0);
        WriteBlock(22, Y0+22, 8, 8, 1, bmp_item[2]);
        TextOut(32, Y0+20, "    װ", 1);
        TextOut(8, Y0+34, "ҷ̹˿ͨװ", 1);
        TextOut(8, Y0+48, "޶ȵӵ", 1);
        TextOut(8, Y0+62, "Ĵ͸͹!", 1);
        Refresh();
        if (getchar() == 27)
        {
            goto MAIN_MENU;
        }

        DrawMenuBorder(0);
        WriteBlock(22, Y0+22, 8, 8, 1, bmp_item[3]);
        TextOut(32, Y0+20, "    ޵л", 1);
        TextOut(8, Y0+34, "޵лܿҷ̹", 1);
        TextOut(8, Y0+48, "һʱھгǿװ", 1);
        TextOut(8, Y0+62, "ȫ˵κι", 1);
        Refresh();
        if (getchar() == 27)
        {
            goto MAIN_MENU;
        }

        DrawMenuBorder(0);
        WriteBlock(22, Y0+22, 8, 8, 1, bmp_item[4]);
        TextOut(32, Y0+20, "    ֧Ԯ", 1);
        TextOut(8, Y0+34, "һ", 1);
        TextOut(8, Y0+48, "Ͷ뵽ս.", 1);
        TextOut(8, Y0+62, "ǿĹ!", 1);
        Refresh();
        if (getchar() == 27)
        {
            goto MAIN_MENU;
        }

        DrawMenuBorder(0);
        WriteBlock(22, Y0+22, 8, 8, 1, bmp_item[5]);
        TextOut(32, Y0+20, "    ʱվֹ", 1);
        TextOut(8, Y0+34, "ʱжʱľֹ,", 1);
        TextOut(8, Y0+48, "ڼҷ̹˿ԶԵ", 1);
        TextOut(8, Y0+62, "̹˽ЧĴ!", 1);
        Refresh();
        if (getchar() == 27)
        {
            goto MAIN_MENU;
        }

        DrawMenuBorder(0);
        WriteBlock(22, Y0+22, 8, 8, 1, bmp_enemy[0][0]);
        TextOut(32, Y0+20, "    ӥ̹", 1);
        TextOut(8, Y0+34, "˵з̹ٶһ,", 1);
        TextOut(8, Y0+48, "ڻƵ൱", 1);
        TextOut(8, Y0+62, "Խкǿƻ!", 1);
        Refresh();
        if (getchar() == 27)
        {
            goto MAIN_MENU;
        }

        DrawMenuBorder(0);
        WriteBlock(22, Y0+22, 8, 8, 1, bmp_enemy[1][0]);
        TextOut(32, Y0+20, "    ɳĮ", 1);
        TextOut(8, Y0+34, "˵з̹ƶٶȿ", 1);
        TextOut(8, Y0+48, ",˵ƶٶȻ", 1);
        TextOut(8, Y0+62, "ҷɽϴв!", 1);
        Refresh();
        if (getchar() == 27)
        {
            goto MAIN_MENU;
        }

        DrawMenuBorder(0);
        WriteBlock(22, Y0+22, 8, 8, 1, bmp_enemy[2][0]);
        TextOut(32, Y0+20, "    Ӣ", 1);
        TextOut(8, Y0+34, "˵з̹ٶȻ", 1);
        TextOut(8, Y0+48, "϶൱", 1);
        TextOut(8, Y0+62, "ǵзĽλ!", 1);
        Refresh();
        if (getchar() == 27)
        {
            goto MAIN_MENU;
        }

        DrawMenuBorder(0);
        TextOut(8, Y0+20, "Ϸͨ", 1);
        TextOut(8, Y0+34, "Pͣ,ͨS", 1);
        TextOut(8, Y0+48, "Rɶȡս۳", 1);
        TextOut(8, Y0+62, "        ף!", 1);
        Refresh();
        if (getchar() == 27)
        {
            goto MAIN_MENU;
        }

        goto MAIN_MENU;
    }
    // ¿Ϸ
    if (select == 0)
    {
        game.maxEnemy = level + 2;// 2 or 3
        if (RoundFirst() == -1)
        {
            goto newgame;
        }
        HideMenu(2);
        NextRound();
    }
    // Ϸ
    if (select == 2)
    {
        HideMenu(0);
        if (GameLoad(0) == -1)
        {
            goto newgame;
        }
        Wait_ReleaseKey();
        //
        DrawSence();
    }
    //
    // gamestart Ϸѭ
    //
    for (;;)
    {
        ms0 = Getms();
        if (game.passDelay > 0)
        {
            if (--game.passDelay == 0)
            {
                if (RoundPass() == 0)
                {
                    NextRound();
                }
                else
                {
                    goto newgame;
                }
            }
        }

        if (game.pauseTime > 0)
        {
            game.pauseTime--;
        }
        if (game.baseTime > 0)
        {
            if (--game.baseTime == 0)
            {
                sence[MAP_H/8-1][7] = 3;
                sence[MAP_H/8-2][7] = 3;
                sence[MAP_H/8-2][8] = 3;
                sence[MAP_H/8-2][9] = 3;
                sence[MAP_H/8-1][9] = 3;
                WriteBlock(56, MAP_H-8, 8, 8, 1, bmp_tile[3]);
                WriteBlock(56, MAP_H-16, 8, 8, 1, bmp_tile[3]);
                WriteBlock(64, MAP_H-16, 8, 8, 1, bmp_tile[3]);
                WriteBlock(72, MAP_H-16, 8, 8, 1, bmp_tile[3]);
                WriteBlock(72, MAP_H-8, 8, 8, 1, bmp_tile[3]);
            }
        }

        //ӵ
        for (i = 0; i < ENEMY_SHOOT; i++)
        {
            if (eg[i].state != 0)
            {
                eg[i].sleep = eg[i].sleep + 1;
                if (eg[i].sleep == 2)
                {
                    eg[i].sleep = 0;
                    if (GunHitBlock(eg[i].x, eg[i].y, i, 0, eg[i].arrow) == 0)
                    {
                        DrawBlank(eg[i].x, eg[i].y);
                        eg[i].x = eg[i].x + eg[i].xspeed;
                        eg[i].y = eg[i].y + eg[i].yspeed;
                        if (GunHitBlock(eg[i].x, eg[i].y, i, 0, eg[i].arrow) == 0)
                        {
                            WriteBlock(eg[i].x, eg[i].y, 8, 8, 0x03, bmp_gun[eg[i].arrow/2]);
                        }
                    }
                }
                //if (eg[i].x >= pg.x - 8 && eg[i].x <= pg.x + 8 && eg[i].y >= pg.y - 8 && eg[i].y <= pg.y + 8 && pg.state != 0)
                if (pg.state != 0)
                {
                    if (pg.x >= eg[i].x - 4 && pg.x <= eg[i].x + 4)
                    if (pg.y >= eg[i].y - 4 && pg.y <= eg[i].y + 4)
                    {
                        pg.state = 0;
                        eg[i].state = 0;
                        DrawBlank(pg.x, pg.y);
                        SetBomb(eg[i].x, eg[i].y);
                    }
                }

                if (game.superTime == 0 && game.deadDelay == 0)
                {
                    if (eg[i].x > game.px - 6 && eg[i].x < game.px + 6 && eg[i].y > game.py - 6 && eg[i].y < game.py + 6)
                    {
                        SetBomb(game.px, game.py);
                        game.pGun = 1;
                        
                        if (game.pLife >  0)
                        {
                            game.pLife--;
                            SetPlayer();
                            DrawInfo();
                        }
                        else
                        {
                            game.deadDelay = SHOW_DEAD_TIME;
                        }
                    }
                }
            }
        }

        //ӵ

        //PlayerWeapon

        if (pg.state != 0)
        {
            DrawBlank(pg.x, pg.y);
            pg.x = pg.x + pg.xspeed;
            pg.y = pg.y + pg.yspeed;

            if (GunHitBlock(pg.x, pg.y, i, 1, pg.arrow) == 0)
            {
                WriteBlock(pg.x, pg.y, 8, 8, 0x03, bmp_gun[pg.arrow/2]);
            }
        }

        ////////////////////
        if (item.state == 1)
        {
            if (item.time % 6 < 3)
            {
                WriteBlock(item.x, item.y, 8, 8, 1, bmp_item[item.style]);
            }
            else
            {
                DrawBlank(item.x, item.y);
            }
            if (--item.time == 0)
            {
                item.state = 0;
                DrawBlank(item.x, item.y);
            }
        }

        ////////////ըĲ
        for (i = 0; i < BOMB_MAX; i++)
        {
            if (bomb[i].state != 0)
            {
                if (bomb[i].id < 5)
                {
                    WriteBlock(bomb[i].x, bomb[i].y, 8, 8, 1, gif_bomb[bomb[i].id]);
                    bomb[i].id = bomb[i].id + 1;
                }
                else
                {
                    DrawBlank(bomb[i].x, bomb[i].y);
                    bomb[i].state = 0;
                }
            }
        }

        ///////////ըĲ
        //ϷߵĿƲ/////////////////////////////////////////////

        key = CheckKey(128);

        if (game.deadDelay > 0)
        {
            key = 0;
            if (--game.deadDelay == 0)
            {
                GameOver();
                goto newgame;
            }
        }
        if (game.deadDelay == 0)
        {
            DrawBlank(game.px, game.py);
        }
        if (((game.px | game.py) & 7) == 0)
        {
            if (CheckKey(KEY_SHOOT) || CheckKey('z'))
            {
                PlayerShoot();
            }
        }
        if (key == KEY_SAVE || key == 's')
        {
            GameSave();
            Wait_ReleaseKey();
        }
        if (key == KEY_READ || key == 'r')
        {
            if (GameLoad(1) == 0)
            {
                DrawSence();
            }
            Wait_ReleaseKey();
        }

        if (key != KEY_UP && key != KEY_DOWN && key != KEY_RIGHT && key != KEY_LEFT)
        {
            arrowsleep = 0;
        }
        if (game.pMove == 0)
        {
            if (key == KEY_UP)
            {
                if (game.pState == 0)
                {
                    if (arrowsleep > 0)
                    {
                        arrowsleep--;
                    }
                    else
                    if (CheckBlock(game.px, game.py, 0, -MoveSpeed, 1, 0) == 0)
                    {
                        game.pMove = 1;
                    }
                }
                else
                {
                    arrowsleep = 1;
                    game.pState = 0;
                }
            }
            if (key == KEY_DOWN)
            {
                if (game.pState == 1)
                {
                    if (arrowsleep > 0)
                    {
                        arrowsleep--;
                    }
                    else
                    if (CheckBlock(game.px, game.py, 0, MoveSpeed, 1, 0) == 0)
                    {
                        game.pMove = 1;
                    }
                }
                else
                {
                    arrowsleep = 1;
                    game.pState = 1;
                }
            }
            if (key == KEY_LEFT)
            {
                if (game.pState == 2)
                {
                    if (arrowsleep > 0)
                    {
                        arrowsleep--;
                    }
                    else
                    if (CheckBlock(game.px, game.py, -MoveSpeed, 0, 1, 0) == 0)
                    {
                        game.pMove = 1;
                    }
                }
                else
                {
                    arrowsleep = 1;
                    game.pState = 2;
                }
            }
            if (key == KEY_RIGHT)
            {
                if (game.pState == 3)
                {
                    if (arrowsleep > 0)
                    {
                        arrowsleep--;
                    }
                    else
                    if (CheckBlock(game.px, game.py, MoveSpeed, 0, 1, 0) == 0)
                    {
                        game.pMove = 1;
                    }
                }
                else
                {
                    arrowsleep = 1;
                    game.pState = 3;
                }
            }
            if (key == KEY_ESC)
            {
                goto newgame;
            }

            if (key == KEY_PAUSE || key == 'p')
            {
                GamePause();
            }
        }
        else
        {
            if (game.pState == 0)
            {
                game.py = game.py - MoveSpeed;
            }
            if (game.pState == 1)
            {
                game.py = game.py + MoveSpeed;
            }
            if (game.pState == 2)
            {
                game.px = game.px - MoveSpeed;
            }
            if (game.pState == 3)
            {
                game.px = game.px + MoveSpeed;
            }
            if (((game.px | game.py) & 7) == 0)
            {
                game.pMove = 0;
            }
        }

        if (game.px > item.x - 8 && game.px < item.x + 8 && game.py > item.y - 8 && game.py < item.y + 8 && item.state == 1)
        {
            DrawBlank(item.x, item.y);
            item.state = 0;
            // ؼӹ
            if (item.style == 0)
            {
                game.baseTime = BASE_TIME;
                sence[MAP_H/8-1][7] = 4;
                sence[MAP_H/8-2][7] = 4;
                sence[MAP_H/8-2][8] = 4;
                sence[MAP_H/8-2][9] = 4;
                sence[MAP_H/8-1][9] = 4;
                WriteBlock(56, MAP_H-8, 8, 8, 1, bmp_tile[4]);
                WriteBlock(56, MAP_H-16, 8, 8, 1, bmp_tile[4]);
                WriteBlock(64, MAP_H-16, 8, 8, 1, bmp_tile[4]);
                WriteBlock(72, MAP_H-16, 8, 8, 1, bmp_tile[4]);
                WriteBlock(72, MAP_H-8, 8, 8, 1, bmp_tile[4]);
            }

            // ȫ
            if (item.style == 1)
            {
                for (i = 0; i < game.maxEnemy; i++)
                {
                    if (en[i].state != 0)
                    {
                        en[i].state = 0;
                        SetBomb(en[i].x, en[i].y);
                        CheckEnemy();
                    }
                }
            }
            // ǹ
            if (item.style == 2)
            {
                if (game.pGun < 3)
                {
                    game.pGun++;
                }
            }
            // ʱ޵
            if (item.style == 3)
            {
                game.superTime = SUPER_TIME;
            }
            // ѷ
            if (item.style == 4)
            {
                if (game.pLife < 9)
                {
                    game.pLife++;
                    DrawInfo();
                }
            }
            // ˶
            if (item.style == 5)
            {
                game.pauseTime = PAUSE_TIME;
            }
        }

        if (game.deadDelay == 0)
        {
            WriteBlock(game.px, game.py, 8, 8, 0x03, bmp_player[game.pState]);
        }
        if (game.superTime > 0)
        {
            if ((--game.superTime & 3) < 2)
            {
                Rectangle(game.px, game.py, game.px + 7, game.py + 7, 1);
            }
        }
        //ϷߵĿƲ/////////////////////////////////////////////

        //˲/////////////////////////////////////////////////////
        for (i = 0; i < game.maxEnemy; i++)
        {
            //ȫѭ
            if (en[i].state == 0 && en[i].showtime > 0)
            {
                if (--en[i].showtime == 0)
                {
                    DrawInfo();
                }
                if (en[i].showtime < SHOW_TIME*3/5)
                {
                    WriteBlock(en[i].x, en[i].y, 8, 8, 1, gif_show[en[i].showtime & 1]);
                }
                if (en[i].showtime == 0)
                {
                    en[i].state = en[i].life;
                }
            }
            //ǻ״̬
            if (en[i].state != 0)
            {
                DrawBlank(en[i].x, en[i].y);
                if (en[i].style == 2)
                {
                    en[i].sleep = en[i].sleep ^ 0xff;
                }
                eblock = CheckBlock(en[i].x, en[i].y, en[i].xspeed & en[i].sleep, en[i].yspeed & en[i].sleep, 0, i);

                if (((en[i].x | en[i].y) & 7) == 0)
                {
                    if (eblock == 20 || rand() % en[i].earrrnd == 0)
                    {
                        SetEnemyArrow(i);
                    }
                    EnemyShoot(en[i].x, en[i].y, en[i].arrow);
                }
                if (eblock > 0)
                {
                    SetEnemyArrow(i);
                }

                //Ƶ/////////////////////////////////////////////////
                WriteBlock(en[i].x, en[i].y, 8, 8, 0x03, bmp_enemy[en[i].style][en[i].arrow]);

                if (pg.state != 0)
                {
                    if (en[i].x > pg.x - 7 && en[i].x < pg.x + 7 && en[i].y > pg.y - 7 && en[i].y < pg.y + 7)
                    {
                        pg.state = 0;
                        DrawBlank(pg.x, pg.y);
                        if (en[i].state > game.pGun)
                        {
                            en[i].state = en[i].state - game.pGun;
                        }
                        else
                        {
                            en[i].state = 0;
                            SetBomb(en[i].x, en[i].y);
                            SetItem(en[i].x, en[i].y);
                            CheckEnemy();
                        }
                    }
                }
                //Ƶ///////////////////////////////////////////
            } //ǻ״̬
        } //ȫѭ
        //˲/////////////////////////////////////////////////////

        Refresh();
        //  Line(144,0,144,79,2);
        if (delaytime >= 4)
        {
        #ifdef USE_TI89
            Delay(delaytime);
        #else
            SyncDelay(delaytime);
        #endif
        }
    }
}
